/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.4a Advanced
Automatic Program Generator
 Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 5/1/2007
Author  : NeVaDa
Company : 
Comments: 
            1390-4-28

Chip type               : ATmega32
Program type            : Application
AVR Core Clock frequency: 8.000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 512
*****************************************************/

#include <mega32.h>
#include <stdio.h>
#include <delay.h>
//#include <..\Maze_Alguritm\Maze.h>
// Data For Motor Left
#define FLM 0x02  //Front Left Motor
#define BLM 0x01  //Back Left Motor
#define SLM 0x00  //Stop Left Motor
 
#define FRM 0x20  //Front Right Motor
#define BRM 0x10  //Back Right Motor
#define SRM 0x00  //Stop Right Motor

#define Front_Motor 0x01
#define Back_Motor 0x02

char Counter,Counter_Sensor;
unsigned int Counter_Right_Motor,Counter_Left_Motor;
int FRS_On,FRS_Off,ValueFRS; // Front Right Sensor
int FLS_On,FLS_Off,ValueFLS; // Front Left Sensor
int RS_On,RS_Off,ValueRS; // Right Sensor
int LS_On,LS_Off,ValueLS; // Left Sensor
char Accuracy_Sensor = 0 ,Counter_Accuracy_Sensor;
char Speed_Right_Motor,Wheel_Right_Motor;
char Speed_Left_Motor,Wheel_Left_Motor;
char PWM_Counter ;

unsigned int read_adc(unsigned char adc_input);
void Save(void)
{}
void Lock(void)
{}

void Front_Half_Size_Home()
{}
void Right_45()// 45 Right
{}

void Left_45()// 45 Left
{}


void Front()
{}
void Front_45()// For Move 45 - Front 1 Home - Eslah
{}
void Back()// 180
{}
void Right()// 90 Right
{}
void Left()// 90 Left
{}
void Right_Arc()// Arc 90 Right
{}
void Left_Arc()// Arc 90 Left
{}
unsigned int Read_Sensor(unsigned char Namber_Sensor_Wall)
// First Wall ==> return 1
// Second Wall ==> return 2
// Non Wall ==> return 0
{
return Namber_Sensor_Wall;
}



  
// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x18 ;PORTB
#endasm
#include <lcd.h>

// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{
// Place your code here
Counter_Right_Motor ++;
}

// External Interrupt 1 service routine
interrupt [EXT_INT1] void ext_int1_isr(void)
{
// Place your code here
Counter_Left_Motor ++;
}

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Place your code here

}

// Timer1 overflow interrupt service routine
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
TCNT1H=0x00;
TCNT1L=0x00;
// Place your code here
    if (Counter_Sensor == 1)
    {
        FRS_Off = 0 ; FRS_On = 0 ;
        FLS_Off = 0 ; FLS_On = 0 ;
        RS_Off = 0 ; RS_On = 0 ;
        LS_Off = 0 ; LS_On = 0 ; 
        PORTC=0x80;   
    }
    else if (Counter_Sensor == 2){FRS_On += read_adc(4);PORTC=0x10;}
    else if (Counter_Sensor == 3){FLS_On += read_adc(7);PORTC=0x40;}
    else if (Counter_Sensor == 4){RS_On += read_adc(5);PORTC=0x20;}
    else if (Counter_Sensor == 5){LS_On += read_adc(6);PORTC=0x00;}
    else if (Counter_Sensor == 6)
    {
        FRS_Off += read_adc(4);
        FLS_Off += read_adc(7); 
        RS_Off += read_adc(5); 
        LS_Off += read_adc(6);      
    }     
    else if (Counter_Sensor == 7)
    {
        if ( Counter_Accuracy_Sensor == Accuracy_Sensor )
        {
            Counter_Accuracy_Sensor = 0;
            Counter_Sensor = 0 ;
            ValueFRS = (FRS_Off - FRS_On) / Accuracy_Sensor + 1 ;
            ValueFLS = (FLS_Off - FLS_On) / Accuracy_Sensor + 1 ;
            ValueRS = (RS_Off - RS_On) / Accuracy_Sensor + 1 ;
            ValueLS = (LS_Off - LS_On) / Accuracy_Sensor + 1 ;
        }
        else
        {
            Counter_Accuracy_Sensor ++ ;
            Counter_Sensor = 1 ;
        }    
    }         
        Counter_Sensor ++ ;
/*        
if ( Speed_Right_Motor <= PWM_Counter )        
    if ( Wheel_Right_Motor == Front_Motor ) 
    {
        PORTD &= 0xfe ; PORTD |= 0x02 ; // Front Right Motor
    }
    else if ( Wheel_Right_Motor == Back_Motor ) 
    {
        PORTD &= 0xef ; PORTD |= 0x20 ; // Front Left Motor
    }
else PORTD &= 0xfc ; // Front Right Motor

if ( Speed_Left_Motor <= PWM_Counter )
    if ( Wheel_Left_Motor == Front_Motor ) 
    {
        PORTD &= 0xfd ; PORTD |= 0x01 ; // Back Right Motor
    }
    else if ( Wheel_Left_Motor == Back_Motor ) 
    {
        PORTD &= 0xdf ; PORTD |= 0x10 ; // Back Left Motor
    }
else PORTD &= 0xcf ; 

if (Counter > 10)PORTD=0x00;
else PORTD=0x22;
Counter++;
if (Counter==10)Counter=0;
*/
}

// Timer2 overflow interrupt service routine
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
// Place your code here

}

#define ADC_VREF_TYPE 0x40

// Read the AD conversion result
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}

void Code_Main(void)
{
// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTC=0x00;
DDRC=0xFF;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTD=0x00;
DDRD=0xf3;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 8000.000 kHz
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x01;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 8000.000 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x01;
TCNT1H=0xF0;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 8000.000 kHz
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x01;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Rising Edge
// INT1: On
// INT1 Mode: Rising Edge
// INT2: Off
GICR|=0xC0;
MCUCR=0x0F;
MCUCSR=0x00;
GIFR=0xC0;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x45;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 1000.000 kHz
// ADC Voltage Reference: AVCC pin
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x83;
}

// Declare your global variables here

void main(void)
{
// Declare your local variables here
char buff[8];

Code_Main();
// LCD module initialization

lcd_init(8);
lcd_putsf("Hamid");
delay_ms(1000);

// Global enable interrupts
#asm("sei")

while (1)
      {
      sprintf(buff,"R:%d ",Counter_Right_Motor);
      lcd_gotoxy(0,0);
      lcd_puts(buff);
      sprintf(buff,"L:%d ",Counter_Left_Motor);
      lcd_gotoxy(0,1);
      lcd_puts(buff);
      delay_ms(50);

/*
        Go_Speed_RPT_NO_Update_Ver2();
        Go_Speed_RPT_NO_Update();
        Go_45_Ver3();
        Go_45_Ver2();
        Go_45();
        Go_Speed_Ver2();
        Go_Speed_RPT();
        Go_Speed();
        Go_Arc();
        Go_RPT();
        Go(); 
        Go_Update3();
*/
      };
}
