/*
 * MazeSouren5.c
 *
 * Created: 7/13/2011 3:35:15 PM
 *  Author: Hamid
 */ 

#include <avr/io.h>
#include <avr/interrupt.h>

#include "../../Maze_Alguritm/Maze.h"

	// Data For Motor Left
	#define FLM 0x02  //Front Left Motor
	#define BLM 0x01  //Back Left Motor
	#define SLM 0x00  //Stop Left Motor
 
	#define FRM 0x20  //Front Right Motor
	#define BRM 0x10  //Back Right Motor
	#define SRM 0x00  //Stop Right Motor

	#define Front_Motor 0x01
	#define Back_Motor 0x02

		char Counter,Counter_Sensor;
		unsigned int Counter_Right_Motor,Counter_Left_Motor;
		int FRS_On,FRS_Off,ValueFRS; // Front Right Sensor
		int FLS_On,FLS_Off,ValueFLS; // Front Left Sensor
		int RS_On,RS_Off,ValueRS; // Right Sensor
		int LS_On,LS_Off,ValueLS; // Left Sensor
		char Accuracy_Sensor = 0 ,Counter_Accuracy_Sensor;
		char Speed_Right_Motor,Wheel_Right_Motor;
		char Speed_Left_Motor,Wheel_Left_Motor;
		char PWM_Counter ;

	//==========================================================================
	//ADC
	# define F_CPU 8000000UL
	#define ADC_VREF_TYPE 0x40
	#include <util/delay.h>

	unsigned int read_adc(unsigned char adc_input)
	{
		ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
		// Delay needed for the stabilization of the ADC input voltage
		_delay_us(10);
		// Start the AD conversion
		ADCSRA|=0x40;
		// Wait for the AD conversion to complete
		while ((ADCSRA & 0x10)==0);
		ADCSRA|=0x10;
		return ADCW;
	}
	//==========================================================================
	//Timer1
	#define ICP PINB0

	//define ovrflow counter

	uint16_t ov_counter;

	//define times for start and end of signal

	uint16_t rising, falling;

	//define overall counts

	uint32_t counts;

	//overflow counter interrupts service routine

	ISR(TIMER1_OVF_vect)
	{
		TCNT1H=0xf0;
		TCNT1L=0x00;
		// Place your code here
			if (Counter_Sensor == 1)
			{
				FRS_Off = 0 ; FRS_On = 0 ;
				FLS_Off = 0 ; FLS_On = 0 ;
				RS_Off = 0 ; RS_On = 0 ;
				LS_Off = 0 ; LS_On = 0 ;    
			}
			else if (Counter_Sensor == 2)PORTC=0x80;
			else if (Counter_Sensor == 3)FRS_On += read_adc(4);
			else if (Counter_Sensor == 4)PORTC=0x10;
			else if (Counter_Sensor == 5)FLS_On += read_adc(7);
			else if (Counter_Sensor == 6)PORTC=0x40;
			else if (Counter_Sensor == 7)RS_On += read_adc(5);
			else if (Counter_Sensor == 8)PORTC=0x20;
			else if (Counter_Sensor == 9)LS_On += read_adc(6);
			else if (Counter_Sensor == 10)
			{
				PORTC=0x00;
			}
			else if (Counter_Sensor == 11)
			{
				FRS_Off += read_adc(4);
				FLS_Off += read_adc(7); 
				RS_Off += read_adc(5); 
				LS_Off += read_adc(6);      
			}     
			else if (Counter_Sensor == 12)
			{
				if ( Counter_Accuracy_Sensor == Accuracy_Sensor )
				{
					Counter_Accuracy_Sensor = 0;
					Counter_Sensor = 0 ;
					ValueFRS = (FRS_Off - FRS_On) / Accuracy_Sensor + 1 ;
					ValueFLS = (FLS_Off - FLS_On) / Accuracy_Sensor + 1 ;
					ValueRS = (RS_Off - RS_On) / Accuracy_Sensor + 1 ;
					ValueLS = (LS_Off - LS_On) / Accuracy_Sensor + 1 ;
				}
				else
				{
					Counter_Accuracy_Sensor ++ ;
					Counter_Sensor = 1 ;
				}    
			}         
				Counter_Sensor ++ ;
        
		if ( Speed_Right_Motor <= PWM_Counter ) 
		{       
			if ( Wheel_Right_Motor == Front_Motor ) 
			{
				PORTD &= 0xfe ; PORTD |= 0x02 ; // Front Right Motor
			}
			else if ( Wheel_Right_Motor == Back_Motor ) 
			{
				PORTD &= 0xef ; PORTD |= 0x20 ; // Front Left Motor
			}
		}		
		else 
			{
				PORTD &= 0xfc ; // Front Right Motor
			}			

		if ( Speed_Left_Motor <= PWM_Counter )
		{
			if ( Wheel_Left_Motor == Front_Motor ) 
			{
				PORTD &= 0xfd ; PORTD |= 0x01 ; // Back Right Motor
			}
			else if ( Wheel_Left_Motor == Back_Motor ) 
			{
				PORTD &= 0xdf ; PORTD |= 0x10 ; // Back Left Motor
			}
		}		
		else 
			{
				PORTD &= 0xcf ; 
			}				

		if (Counter > 10)PORTD=0x00;
		else PORTD=0x22;
		Counter++;
		if (Counter==10)Counter=0;

			//TCNT1H=0x80;//????? ??? ????? ????? ??? ?? ????
			//TCNT1L=0x00;//????? ??? ????? ????? ??? ?? ????

	/*
	  ov_counter++;
	  DDRC=0XFF;
	  DDRB=0XFF;
	  PORTB=ov_counter;
	if (PORTC==0xff)PORTC=0X00;
	else PORTC = 0XFF;
	*/
	}

	//Timer1 capture interrupt service subroutine

	ISR(TIMER1_CAPT_vect){



	/*This subroutine checks was it start of pulse (rising edge)

	or was it end (fallingedge)and performs required operations*/

	/*
	if (ICP) //if high level

				{

				//save start time

				rising=ICR1;

				//set to trigger on falling edge

				TCCR1B=TCCR1B&0xBF;

				//reset overflow counter

				ov_counter=0;

	   }

	else

				{

				//save falling time

				falling=ICR1;

				//rising edge triggers next

				TCCR1B=TCCR1B|0x40;

				counts=(uint32_t)falling-(uint32_t)rising+(uint32_t)ov_counter;

				//you can convert coutns to seconds and send to LCD

				}
	*/

	}

	void Save(void)
	{}
	void Lock(void)
	{}

	void Front_Half_Size_Home()
	{}
	void Right_45()// 45 Right
	{}

	void Left_45()// 45 Left
	{}
	void Front()
	{}
	void Front_45()// For Move 45 - Front 1 Home - Eslah
	{}
	void Back()// 180
	{}
	void Right()// 90 Right
	{}
	void Left()// 90 Left
	{}
	void Right_Arc()// Arc 90 Right
	{}
	void Left_Arc()// Arc 90 Left
	{}
	unsigned int Read_Sensor(unsigned char Namber_Sensor_Wall)
	// First Wall ==> return 1
	// Second Wall ==> return 2
	// Non Wall ==> return 0
	{
		return Namber_Sensor_Wall;
	}
	void Code_Main(void)
	{
		// Analog Comparator initialization
		// Analog Comparator: Off
		// Analog Comparator Input Capture by Timer/Counter 1: Off
		ACSR=0x80;
		SFIOR=0x00;
	
	
		// ADC initialization
		// ADC Clock frequency: 1000.000 kHz
		// ADC Voltage Reference: AVCC pin
		// ADC Auto Trigger Source: ADC Stopped
		ADMUX=ADC_VREF_TYPE & 0xff;
		ADCSRA=0x83;
		
		//--------------------------------------------------------
		//Timer1

		//enable overflow and input capture interrupts

		TIMSK=0x24;

		/*Noise canceller, without prescaler, rising edge*/

		TCCR1B=0xC1;

		sei();//Enable Gobale Interrupts 

	}
int main(void)
{
	Code_Main();
    while(1)
    {
        //TODO:: Please write your application code 
    }
}