/*
Program         :    Algorithm Maze Robot
Version         :    5.0.3.634
Programer       :    Hamid Davoodi Shandiz
Date            :    1389 - 06 - 18
Date Update 1   :    1389 - 08 - 04
Date Update 2   :    1389 - 09 - 11
Date Update 3   :    1389 - 09 - 16
Date Update 4   :    1389 - 10 - 09  Test & OK
Date Update 5   :    1389 - 11 - 03  Micro C Pro AVR
Date Update 6   :    1389 - 11 - 23  New Update
Date Update 7   :    1390 - 02 - 08  Small Way
Date Update 8   :    1390 - 03 - 07  New Update Ver 2
Date Update 9   :    1390 - 03 - 20  Update (Update_Ver_2_1)
Date Update 10  :    1390 - 03 - 28  Update (Update_Ver_3)
Date Update 11  :    1390 - 04 - 22  
Compiler        :    Avr GCC - AVR Studio 5 - AVR Studio 4 - CodeVision AVR - MicroC Pro AVR - Visual C++ And Orther Language C & C++
Comment         :

    Update 4   1389 - 10 - 09 ===> Test Algorithm And Check On Sourena Robot ( IAUM Robotic )
	Update 5   1389 - 11 - 03 ===> Add Compiler Micro C Pro AVR - Visual C++ And Orther Language C & C++
	Update 6   1389 - 11 - 23 ===> New Update  :  4000000 Run Command
							  ===> New Update  :  Maximum Time For Update  = 500 Mili Second With Proccesor 8 Million Command in Second - 8 MHz
	Update 7   1390 - 02 - 08 ===> Find Small Wey Not Small Point  
	Update 8   1390 - 03 - 07 ===> New Update Ver 2 = 5000 Run Command - Problem For Close Home
	Update 9   1390 - 03 - 20 ===> Update (Update_Ver_2_1) - No Problem For Close Home - 1300 Byte Use For Update 
	Update 10  1390 - 03 - 28 ===> Update (Update_Ver_3) - 700 Byte Use For Update
*/
/*
 90 & 45 & Arc

 NW     N     NE
    \   |   /
     \  |  /
      \ | /
W ------|------ E
      / | \
     /  |  \
    /   |   \
 SW     S     SE                     

=====>  Star Main Program  <=====

        Index_Robot.X =0;
        Index_Robot.Y =0;

        Finish_Home_1.X =7;
        Finish_Home_1.Y =7;
        Finish_Home_2.X =8;
        Finish_Home_2.Y =7;
        Finish_Home_3.X =7;
        Finish_Home_3.Y =8;
        Finish_Home_4.X =8;
        Finish_Home_4.Y =8;

        while (1)
            {
                Go();
            }
*/
//#ifndef LED_Update
//        #define LED_Update PORTE.0   // For Mega 128
//#endif

#define N 0x08                       // North
#define NE 0x0c                      // North & East
#define E 0x04                       // East
#define SE1 0x06                      // South & East
#define S 0x02                       // South
#define SW 0x03                      // South & West
#define W 0x01                       // West
#define NW 0x09                      // North & West

#define RPT 0x80                     // Repeat
#define RS 0x00                         // Right Sensor
#define FS 0x01                         // Front Sensor
#define LS 0x02                         // Left Sensor

#define Move_45 1                     // Type Move 45
#define Move_90 0                     // Type Move 90

#define On_ALG 1
#define Off_ALG 0

#define Point_Center 0x0F
#define Point_Up     0x01
#define Point_Down   0x02
#define Point_Right  0x04
#define Point_Left   0x08

        struct X_Y
        {
            char X;
            char Y;
        };
        struct X_Y Index_Robot;  //  X , Y  Robot
//        struct X_Y Index_Robot_RPT;  //  X , Y  Robot For Repeat (RPT)
        struct X_Y Finish_Home_1;
        struct X_Y Finish_Home_2;
        struct X_Y Finish_Home_3;
        struct X_Y Finish_Home_4;
    char Angle_Robot = N;
    char Angle_Move_Robot_First;
    char Angle_Move_Robot_Second;
    char Back_Way = 0;
    unsigned char Len_Way = 0;
    unsigned char Len_Way_A = 0;
    char Small_Len_Way = Off_ALG;
    char Check_Home_Finish = Off_ALG;
    char Sens_Sensor;
    char Type_Move = 0;   //        ј
    char Model_Move = Off_ALG;    
    char Index_Robot_Point = Point_Center;
    // Update
        char IndexA=0;     //  
        char Switch = 0;
        char And;
        char And_x;
    // =======
    // Update Ver2 === Short Time

    //    struct Value_X_Y
    //        {
    //            char Value;
    //            char X_2;
    //            char Y_2;
    //        };
        
        //struct Value_X_Y Home_Update2[256];     
	//	struct Value_X_Y Home_Update3[58];
    // =======
    //    Small Ways
    //    struct X_Y Ways[4][254];
    //    struct X_Y IPW_A; // Index Point Way A  
    //    struct X_Y IPW_B; // Index Point Way B
    //    struct X_Y IPW_C; // Index Point Way C
    //    struct X_Y IPW_D; // Index Point Way D
    //    unsigned char Index_Way ;
    //    unsigned char Max_Way ;
    //========
    //char Move_Darage;
    unsigned int i,j,k,l;
unsigned char Homes[16][16]=
        {
        //   1 ,2 ,3 ,4 ,5 ,6 ,7 ,8 ,9 ,10,11,12,13,14,15,16
        //------------------------------------------------------
        {14,13,12,11,10, 9, 8, 7, 7, 8, 9,10,11,12,13,14},  // 1
        {13,12,11,10, 9, 8, 7, 6, 6, 7, 8, 9,10,11,12,13},  // 2
        {12,11,10, 9, 8, 7, 6, 5, 5, 6, 7, 8, 9,10,11,12},  // 3
        {11,10, 9, 8, 7, 6, 5, 4, 4, 5, 6, 7, 8, 9,10,11},  // 4
        {10, 9, 8, 7, 6, 5, 4, 3, 3, 4, 5, 6, 7, 8, 9,10},  // 5
        { 9, 8, 7, 6, 5, 4, 3, 2, 2, 3, 4, 5, 6, 7, 8, 9},  // 6
        { 8, 7, 6, 5, 4, 3, 2, 1, 1, 2, 3, 4, 5, 6, 7, 8},  // 7
        { 7, 6, 5, 4, 3, 2, 1, 0, 0, 1, 2, 3, 4, 5, 6, 7},  // 8
        { 7, 6, 5, 4, 3, 2, 1, 0, 0, 1, 2, 3, 4, 5, 6, 7},  // 9
        { 8, 7, 6, 5, 4, 3, 2, 1, 1, 2, 3, 4, 5, 6, 7, 8},  // 10
        { 9, 8, 7, 6, 5, 4, 3, 2, 2, 3, 4, 5, 6, 7, 8, 9},  // 11
        {10, 9, 8, 7, 6, 5, 4, 3, 3, 4, 5, 6, 7, 8, 9,10},  // 12
        {11,10, 9, 8, 7, 6, 5, 4, 4, 5, 6, 7, 8, 9,10,11},  // 13
        {12,11,10, 9, 8, 7, 6, 5, 5, 6, 7, 8, 9,10,11,12},  // 14
        {13,12,11,10, 9, 8, 7, 6, 6, 7, 8, 9,10,11,12,13},  // 15
        {14,13,12,11,10, 9, 8, 7, 7, 8, 9,10,11,12,13,14}   // 16

        };
#ifndef ___Wall_Homes_Maze___
unsigned char Wall_Homes[16][16]=                 //  RPT  0  0  0  N  E  S  W
        {
          {3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,9},     // 1
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 2
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 3
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 4
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 5
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 6
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 7
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 8
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 9
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 10
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 11
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 12
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 13
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 14
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 15
          {6,4,4,4,4,4,4,4,4,4,4,4,4,4,4,12}     // 16
        };
#endif

/*
unsigned char Wall_Homes[16][16]=                 //  RPT  0  0  0  N  E  S  W
        {
          {3,5,5,5,5,5,5,5,5,5,5,5,5,5,5,9},     // 1
          {10,2,7,7,7,7,7,7,7,7,7,7,7,7,3,12},     // 2
          {10,2,6,9,0,0,0,0,0,0,0,0,0,3,12,8},     // 3
          {10,2,0,6,9,0,0,0,0,0,0,0,3,12,0,8},     // 4
          {10,2,0,0,6,9,0,0,0,0,0,3,12,0,0,8},     // 5
          {10,2,0,0,0,6,9,0,0,0,3,12,0,0,0,8},     // 6
          {10,2,0,0,0,0,6,9,0,3,12,0,0,0,0,8},     // 7
          
          {10,2,0,0,0,0,0,  3,9,  0,0,0,0,0,0,8},     // 8
          {10,2,0,0,0,0,0,  2,12, 0,0,0,0,0,0,8},     // 9
          
          {10,2,0,0,0,0,3,12,0,0,0,0,0,0,0,8},     // 10
          {10,2,0,0,0,3,12,0,0,0,0,0,0,0,0,8},     // 11
          {10,2,0,0,3,12,0,0,0,0,0,0,0,0,0,8},     // 12
          {10,2,0,3,12,0,0,0,0,0,0,0,0,0,0,8},     // 13
          {10,6,3,12,0,0,0,0,0,0,0,0,0,0,0,8},     // 14
          {10,3,12,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 15
          {6,12,4,4,4,4,4,4,4,4,4,4,4,4,4,12}     // 16
        };
*/
void Save(void);
void Lock(void);

void Front_Half_Size_Home();//{}
void Right_45();//{}
// 45 Right
void Left_45();//{}
// 45 Left

void Front();//{}
void Front_45();//{}// For Move 45
// Front 1 Home
// Eslah
void Back();//{}
// 180
void Right();//{}
// 90 Right
void Left();//{}
// 90 Left
void Right_Arc();//{}
// Arc 90 Right
void Left_Arc();//{}
// Arc 90 Left
unsigned int Read_Sensor(unsigned char Namber_Sensor_Wall);//{}
// First Wall ==> return 1
// Second Wall ==> return 2
// Non Wall ==> return 0

/*
void Check_Wall()         //     
    {
        // Check Walls   ====================================================================
        // Read_Sensor(RS)    Right Sensor ROBOT
        // Read_Sensor(Fs)    Front Sensor ROBOT
        // Read_Sensor(Ls)    Left  Sensor ROBOT
        if ( Angle_Robot == N )
        {
            Sens_Sensor = Read_Sensor(RS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= E ;             // Right Sensor Wall One
                if ( Index_Robot.X < 15 ) Wall_Homes[ Index_Robot.X + 1 ] [ Index_Robot.Y ] |= W ;
            }
            else if (Sens_Sensor == 2)
            {
                Wall_Homes[ Index_Robot.X + 1 ] [ Index_Robot.Y ] |= E ;     // Right Sensor Wall Two
                if ( Index_Robot.X < 14 ) Wall_Homes[ Index_Robot.X + 2 ] [ Index_Robot.Y ] |= W ;
            }
            Sens_Sensor = Read_Sensor(FS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= N ;             // Front Sensor Wall One
                if ( Index_Robot.Y < 15 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y + 1 ] |= S ;
            }
            else if (Sens_Sensor == 2)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y + 1 ] |= N;     // Front Sensor Wall Two
                if ( Index_Robot.Y < 14 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y + 2 ] |= S;
            }
            Sens_Sensor = Read_Sensor(LS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= W ;             // Back Sensor Wall One
                if ( Index_Robot.X > 0 ) Wall_Homes[ Index_Robot.X - 1 ] [ Index_Robot.Y ] |= E ;
            }
            else if (Sens_Sensor == 2)
            {
                Wall_Homes[ Index_Robot.X - 1 ] [ Index_Robot.Y ] |= W ;     // Back Sensor Wall Two
                if ( Index_Robot.X > 1 ) Wall_Homes[ Index_Robot.X - 2 ] [ Index_Robot.Y ] |= E ;
            }
        }
// --------------------------------------------------------------------------
        else if ( Angle_Robot == E )
        {
            Sens_Sensor = Read_Sensor(RS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= S ;             // Right Sensor Wall One
                if ( Index_Robot.Y > 0 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y - 1 ] |= N ;
            }
            else if (Sens_Sensor == 2)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y - 1 ] |= S ;     // Right Sensor Wall Two
                if ( Index_Robot.Y > 1 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y - 2 ] |= N ;
            }
            Sens_Sensor = Read_Sensor(FS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= E ;             // Right Sensor Wall One
                if ( Index_Robot.X < 15 ) Wall_Homes[ Index_Robot.X + 1 ] [ Index_Robot.Y ] |= W ;
            }
            else if (Sens_Sensor == 2)
            {
                Wall_Homes[ Index_Robot.X + 1 ] [ Index_Robot.Y ] |= E ;     // Right Sensor Wall Two
                if ( Index_Robot.X < 14 ) Wall_Homes[ Index_Robot.X + 2 ] [ Index_Robot.Y ] |= W ;
            }
            Sens_Sensor = Read_Sensor(LS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= N ;             // Front Sensor Wall One
                if ( Index_Robot.Y < 15 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y + 1 ] |= S ;
            }
            else if (Sens_Sensor == 2)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y + 1 ] |= N;     // Front Sensor Wall Two
                if ( Index_Robot.X < 14 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y + 2 ] |= S;
            }
        }
// --------------------------------------------------------------------------

        else if ( Angle_Robot == S )
        {
            Sens_Sensor = Read_Sensor(RS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= W ;             // Back Sensor Wall One
                if ( Index_Robot.X > 0 ) Wall_Homes[ Index_Robot.X - 1 ] [ Index_Robot.Y ] |= E ;
            }
            else if (Sens_Sensor == 2)
            {
                Wall_Homes[ Index_Robot.X - 1 ] [ Index_Robot.Y ] |= W ;     // Back Sensor Wall Two
                if ( Index_Robot.X > 1 ) Wall_Homes[ Index_Robot.X - 2 ] [ Index_Robot.Y ] |= E ;
            }
            Sens_Sensor = Read_Sensor(FS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= S ;             // Right Sensor Wall One
                if ( Index_Robot.X > 0 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y - 1 ] |= N ;
            }
            else if (Sens_Sensor == 2)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y - 1 ] |= S ;     // Right Sensor Wall Two
                if ( Index_Robot.X > 1 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y - 2 ] |= N ;
            }
            Sens_Sensor = Read_Sensor(LS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= E ;             // Right Sensor Wall One
                if ( Index_Robot.X < 15 ) Wall_Homes[ Index_Robot.X + 1 ] [ Index_Robot.Y ] |= W ;
            }
            else if (Sens_Sensor == 2)
            {
                Wall_Homes[ Index_Robot.X + 1 ] [ Index_Robot.Y ] |= E ;     // Right Sensor Wall Two
                if ( Index_Robot.X < 14 ) Wall_Homes[ Index_Robot.X + 2 ] [ Index_Robot.Y ] |= W ;
            }
        }
         // --------------------------------------------------------------------------
        else if ( Angle_Robot == W )
        {
            Sens_Sensor = Read_Sensor(RS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= N ;             // Back Sensor Wall One
                if ( Index_Robot.Y < 15 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y + 1 ] |= S ;
            }
            else if (Sens_Sensor == 2)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y + 1 ] |= N ;             // Back Sensor Wall One
                if ( Index_Robot.Y < 14 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y + 2 ] |= S ;
            }
            Sens_Sensor = Read_Sensor(FS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= W ;             // Right Sensor Wall One
                if ( Index_Robot.X > 0 ) Wall_Homes[ Index_Robot.X - 1 ] [ Index_Robot.Y ] |= E ;
            }
            else if (Sens_Sensor == 2)
            {
                Wall_Homes[ Index_Robot.X - 1 ] [ Index_Robot.Y ] |= W ;             // Right Sensor Wall One
                if ( Index_Robot.X > 1 ) Wall_Homes[ Index_Robot.X - 2 ] [ Index_Robot.Y ] |= E ;
            }
            Sens_Sensor = Read_Sensor(LS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= S ;             // Right Sensor Wall One
                if ( Index_Robot.X > 0 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y - 1 ] |= N ;
            }
            else if (Sens_Sensor == 2)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y - 1 ] |= S ;     // Right Sensor Wall Two
                if ( Index_Robot.X > 1 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y - 2 ] |= N ;
            }
        }
        // End Check Walls   ================================================================
    }
*/

void Check_Wall()
    {
        // Check Walls   ====================================================================
        // Read_Sensor(RS)    Right Sensor ROBOT
        // Read_Sensor(Fs)    Front Sensor ROBOT
        // Read_Sensor(Ls)    Left  Sensor ROBOT
        if ( Angle_Robot == N )
        {
            Sens_Sensor = Read_Sensor(RS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= E ;             // Right Sensor Wall One
                if ( Index_Robot.X < 15 ) Wall_Homes[ Index_Robot.X + 1 ] [ Index_Robot.Y ] |= W ;
            }
            Sens_Sensor = Read_Sensor(FS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= N ;             // Front Sensor Wall One
                if ( Index_Robot.Y < 15 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y + 1 ] |= S ;
            }
            Sens_Sensor = Read_Sensor(LS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= W ;             // Back Sensor Wall One
                if ( Index_Robot.X > 0 ) Wall_Homes[ Index_Robot.X - 1 ] [ Index_Robot.Y ] |= E ;
            }
        }
// --------------------------------------------------------------------------
        else if ( Angle_Robot == E )
        {
            Sens_Sensor = Read_Sensor(RS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= S ;             // Right Sensor Wall One
                if ( Index_Robot.Y > 0 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y - 1 ] |= N ;
            }
            Sens_Sensor = Read_Sensor(FS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= E ;             // Right Sensor Wall One
                if ( Index_Robot.X < 15 ) Wall_Homes[ Index_Robot.X + 1 ] [ Index_Robot.Y ] |= W ;
            }
            Sens_Sensor = Read_Sensor(LS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= N ;             // Front Sensor Wall One
                if ( Index_Robot.Y < 15 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y + 1 ] |= S ;
            }
        }
// --------------------------------------------------------------------------

        else if ( Angle_Robot == S )
        {
            Sens_Sensor = Read_Sensor(RS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= W ;             // Back Sensor Wall One
                if ( Index_Robot.X > 0 ) Wall_Homes[ Index_Robot.X - 1 ] [ Index_Robot.Y ] |= E ;
            }
            Sens_Sensor = Read_Sensor(FS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= S ;             // Right Sensor Wall One
                if ( Index_Robot.Y > 0 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y - 1 ] |= N ;
            }
            Sens_Sensor = Read_Sensor(LS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= E ;             // Right Sensor Wall One
                if ( Index_Robot.X < 15 ) Wall_Homes[ Index_Robot.X + 1 ] [ Index_Robot.Y ] |= W ;
            }
        }
         // --------------------------------------------------------------------------
        else if ( Angle_Robot == W )
        {
            Sens_Sensor = Read_Sensor(RS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= N ;             // Back Sensor Wall One
                if ( Index_Robot.Y < 15 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y + 1 ] |= S ;
            }
            Sens_Sensor = Read_Sensor(FS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= W ;             // Right Sensor Wall One
                if ( Index_Robot.X > 0 ) Wall_Homes[ Index_Robot.X - 1 ] [ Index_Robot.Y ] |= E ;
            }
            Sens_Sensor = Read_Sensor(LS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= S ;             // Right Sensor Wall One
                if ( Index_Robot.Y > 0 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y - 1 ] |= N ;
            }
        }
        // End Check Walls   ================================================================
    }
void Darage(char DRG)
    {
        if (DRG == N )
            {
                if (Angle_Robot==E)Left();
                else if (Angle_Robot==W)Right();
                else if (Angle_Robot==S)Back();

                else if (Angle_Robot==NW)Right_45();
                else if (Angle_Robot==NE)Left_45();
                else if (Angle_Robot==SW){Right();Right_45();}
                else if (Angle_Robot==SE1){Left();Left_45();}
                Angle_Robot=N;
            }
        else if (DRG == E )
            {
                if (Angle_Robot==S)Left();
                else if (Angle_Robot==N)Right();
                else if (Angle_Robot==W)Back();

                else if (Angle_Robot==NE)Right_45();
                else if (Angle_Robot==SE1)Left_45();
                else if (Angle_Robot==NW){Right();Right_45();}
                else if (Angle_Robot==SW){Left();Left_45();}
                Angle_Robot=E;
            }
        else if (DRG == S )
            {
                if (Angle_Robot==W)Left();
                else if (Angle_Robot==E)Right();
                else if (Angle_Robot==N)Back();

                else if (Angle_Robot==SE1)Right_45();
                else if (Angle_Robot==SW)Left_45();
                else if (Angle_Robot==NE){Right();Right_45();}
                else if (Angle_Robot==NW){Left();Left_45();}
                Angle_Robot=S;
            }
        else if (DRG == W )
            {
                if (Angle_Robot==N)Left();
                else if (Angle_Robot==S)Right();
                else if (Angle_Robot==E)Back();

                else if (Angle_Robot==SW)Right_45();
                else if (Angle_Robot==NW)Left_45();
                else if (Angle_Robot==SE1){Right();Right_45();}
                else if (Angle_Robot==NE){Left();Left_45();}
                Angle_Robot=W;
            }
        else if (DRG == NE )
            {
                if (Angle_Robot==SE1)Left();
                else if (Angle_Robot==NW)Right();
                else if (Angle_Robot==SW)Back();

                else if (Angle_Robot==N)Right_45();
                else if (Angle_Robot==E)Left_45();
                else if (Angle_Robot==W){Right();Right_45();}
                else if (Angle_Robot==S){Left();Left_45();}
                Angle_Robot=NE;
            }
        else if (DRG == NW )
            {
                if (Angle_Robot==NE)Left();
                else if (Angle_Robot==SW)Right();
                else if (Angle_Robot==SE1)Back();

                else if (Angle_Robot==W)Right_45();
                else if (Angle_Robot==N)Left_45();
                else if (Angle_Robot==S){Right();Right_45();}
                else if (Angle_Robot==E){Left();Left_45();}
                Angle_Robot=NW;
            }
        else if (DRG == SW )
            {
                if (Angle_Robot==NW)Left();
                else if (Angle_Robot==SE1)Right();
                else if (Angle_Robot==NE)Back();

                else if (Angle_Robot==S)Right_45();
                else if (Angle_Robot==W)Left_45();
                else if (Angle_Robot==E){Right();Right_45();}
                else if (Angle_Robot==N){Left();Left_45();}
                Angle_Robot=SW;
            }
        else if (DRG == SE1 )
            {
                if (Angle_Robot==SW)Left();
                else if (Angle_Robot==NE)Right();
                else if (Angle_Robot==NW)Back();

                else if (Angle_Robot==E)Right_45();
                else if (Angle_Robot==S)Left_45();
                else if (Angle_Robot==N){Right();Right_45();}
                else if (Angle_Robot==W){Left();Left_45();}
                Angle_Robot=SE1;
            }
    }
void Darage_Arc(char DRG)
    {
        if (DRG == N )
            {
                if (Angle_Robot==E)Left_Arc();
                else if (Angle_Robot==W)Right_Arc();
                else if (Angle_Robot==S)Back();
                Angle_Robot=N;
            }
        else if (DRG == E )
            {
                if (Angle_Robot==S)Left_Arc();
                else if (Angle_Robot==N)Right_Arc();
                else if (Angle_Robot==W)Back();
                Angle_Robot=E;
            }
        else if (DRG == S )
            {
                if (Angle_Robot==W)Left_Arc();
                else if (Angle_Robot==E)Right_Arc();
                else if (Angle_Robot==N)Back();
                Angle_Robot=S;
            }
        else if (DRG == W )
            {
                if (Angle_Robot==N)Left_Arc();
                else if (Angle_Robot==S)Right_Arc();
                else if (Angle_Robot==E)Back();
                Angle_Robot=W;
            }
    }
/*
void Darage(char DRG)     //      
    {
        if (DRG == N )
            {
                if (Angle_Robot==E)Left();
                else if (Angle_Robot==W)Right();
                else if (Angle_Robot==S)Back();

                else if (Angle_Robot==NW)Right_45();
                else if (Angle_Robot==NE)Left_45();
                else if (Angle_Robot==SW){Right();Right_45();}
                else if (Angle_Robot==SE1){Left();Left_45();}
                Angle_Robot=N;
            }
        else if (DRG == E )
            {
                if (Angle_Robot==S)Left();
                else if (Angle_Robot==N)Right();
                else if (Angle_Robot==W)Back();

                else if (Angle_Robot==NE)Right_45();
                else if (Angle_Robot==SE1)Left_45();
                else if (Angle_Robot==NW){Right();Right_45();}
                else if (Angle_Robot==SW){Left();Left_45();}
                Angle_Robot=E;
            }
        else if (DRG == S )
            {
                if (Angle_Robot==W)Left();
                else if (Angle_Robot==E)Right();
                else if (Angle_Robot==N)Back();

                else if (Angle_Robot==SE1)Right_45();
                else if (Angle_Robot==SW)Left_45();
                else if (Angle_Robot==NE){Right();Right_45();}
                else if (Angle_Robot==NW){Left();Left_45();}
                Angle_Robot=S;
            }
        else if (DRG == W )
            {
                if (Angle_Robot==N)Left();
                else if (Angle_Robot==S)Right();
                else if (Angle_Robot==E)Back();

                else if (Angle_Robot==SW)Right_45();
                else if (Angle_Robot==NW)Left_45();
                else if (Angle_Robot==SE1){Right();Right_45();}
                else if (Angle_Robot==NE){Left();Left_45();}
                Angle_Robot=W;
            }
        else if (DRG == NE )
            {
                if (Angle_Robot==SE1)Left();
                else if (Angle_Robot==NW)Right();
                else if (Angle_Robot==SW)Back();

                else if (Angle_Robot==N)Right_45();
                else if (Angle_Robot==E)Left_45();
                else if (Angle_Robot==W){Right();Right_45();}
                else if (Angle_Robot==S){Left();Left_45();}
                Angle_Robot=NE;
            }
        else if (DRG == NW )
            {
                if (Angle_Robot==NE)Left();
                else if (Angle_Robot==SW)Right();
                else if (Angle_Robot==SE1)Back();

                else if (Angle_Robot==W)Right_45();
                else if (Angle_Robot==N)Left_45();
                else if (Angle_Robot==S){Right();Right_45();}
                else if (Angle_Robot==E){Left();Left_45();}
                Angle_Robot=NW;
            }
        else if (DRG == SW )
            {
                if (Angle_Robot==NW)Left();
                else if (Angle_Robot==SE1)Right();
                else if (Angle_Robot==NE)Back();

                else if (Angle_Robot==S)Right_45();
                else if (Angle_Robot==W)Left_45();
                else if (Angle_Robot==E){Right();Right_45();}
                else if (Angle_Robot==N){Left();Left_45();}
                Angle_Robot=SW;
            }
        else if (DRG == SE1 )
            {
                if (Angle_Robot==SW)Left();
                else if (Angle_Robot==NE)Right();
                else if (Angle_Robot==NW)Back();

                else if (Angle_Robot==E)Right_45();
                else if (Angle_Robot==S)Left_45();
                else if (Angle_Robot==N){Right();Right_45();}
                else if (Angle_Robot==W){Left();Left_45();}
                Angle_Robot=SE1;
            }
    }
void Darage_Arc(char DRG) //            
    {
        if (DRG == N )
            {
                if (Angle_Robot==E)Left_Arc();
                else if (Angle_Robot==W)Right_Arc();
                else if (Angle_Robot==S)Back();
                Angle_Robot=N;
            }
        else if (DRG == E )
            {
                if (Angle_Robot==S)Left_Arc();
                else if (Angle_Robot==N)Right_Arc();
                else if (Angle_Robot==W)Back();
                Angle_Robot=E;
            }
        else if (DRG == S )
            {
                if (Angle_Robot==W)Left_Arc();
                else if (Angle_Robot==E)Right_Arc();
                else if (Angle_Robot==N)Back();
                Angle_Robot=S;
            }
        else if (DRG == W )
            {
                if (Angle_Robot==N)Left_Arc();
                else if (Angle_Robot==S)Right_Arc();
                else if (Angle_Robot==E)Back();
                Angle_Robot=W;
            }
    }
*/
/*
void Update()             //         Ԙ    
    {

        LED_Update = 1;

        for (i=0; i<16;i++)
            for (j=0; j<16;j++)
                Homes[i][j]=0xff;

            Homes[Finish_Home_1.X][Finish_Home_1.Y]=0x00;
            Homes[Finish_Home_2.X][Finish_Home_2.Y]=0x00;
            Homes[Finish_Home_3.X][Finish_Home_3.Y]=0x00;
            Homes[Finish_Home_4.X][Finish_Home_4.Y]=0x00;

        for(IndexA=0x00;IndexA<=0xfb;IndexA++)
        {
            for(i=0;i<16;i++)
                for(j=0;j<16;j++)
                    if(Homes[i][j]==IndexA)
                    {
                        //And = 0x08;      //      North
                        And = N & Wall_Homes[i][j];
                        if ( And == 0x00 )
                            if( Homes[i][j+1]==0xff ) { Homes[i][j+1]=IndexA+1; Switch=1; }
                        //And = 0x04;      //      East
                        And = E & Wall_Homes[i][j];
                        if ( And == 0x00 )
                            if( Homes[i+1][j]==0xff ) { Homes[i+1][j]=IndexA+1; Switch=1; }
                        //And = 0x01;      //      West
                        And = W & Wall_Homes[i][j];
                        if ( And == 0x00 )
                            if( Homes[i-1][j]==0xff ) { Homes[i-1][j]=IndexA+1; Switch=1; }
                        //And = 0x02;      //      South
                        And = S & Wall_Homes[i][j];
                        if ( And == 0x00 )
                            if( Homes[i][j-1]==0xff ) { Homes[i][j-1]=IndexA+1; Switch=1; }
                    }
            if (Switch == 0) IndexA=0xfb;
            else Switch = 0;
        }
        LED_Update = 0 ;
    }
*/
void Update()
    {
        Lock();
//        LED_Update = 1;

        for (i=0; i<16;i++)
            for (j=0; j<16;j++)
                Homes[i][j]=0xff;

            Homes[Finish_Home_1.X][Finish_Home_1.Y]=0x00;
            Homes[Finish_Home_2.X][Finish_Home_2.Y]=0x00;
            Homes[Finish_Home_3.X][Finish_Home_3.Y]=0x00;
            Homes[Finish_Home_4.X][Finish_Home_4.Y]=0x00;

        for(IndexA=0x00;IndexA<=0xfb;IndexA++)
        {
            for(i=0;i<16;i++)
                for(j=0;j<16;j++)
                    if(Homes[i][j]==IndexA)
                    {
                        And_x = N & Wall_Homes[i][j] ;
                        if ( And_x == 0x00 )
                            if( Homes[i][j+1]==0xff )
                            {
                            Homes[i][j+1]=IndexA+1;
                            Switch=1;
                            }

                        And_x = E & Wall_Homes[i][j] ;
                        if ( And_x == 0x00 )
                            if( Homes[i+1][j]==0xff )
                            {
                            Homes[i+1][j]=IndexA+1;
                            Switch=1;
                            }

                        And_x = W & Wall_Homes[i][j] ;
                        if ( And_x == 0x00 )
                            if( Homes[i-1][j]==0xff )
                            {
                            Homes[i-1][j]=IndexA+1;
                            Switch=1;
                            }

                        And_x = S & Wall_Homes[i][j] ;
                        if ( And_x == 0x00 )
                            if( Homes[i][j-1]==0xff )
                            {
                            Homes[i][j-1]=IndexA+1;
                            Switch=1;
                            }
                    }
            if (Switch == 0) 
				IndexA = 0xfb ;
            else Switch = 0;
        }
//        LED_Update = 0 ;
    }

/*
void Update_Ver2()
    {
        Lock();
//        LED_Update = 1;

        for (i=0; i<16;i++)
            for (j=0; j<16;j++)
                Homes[i][j]=0xff;
                
            Homes[Finish_Home_1.X][Finish_Home_1.Y]=0x00;
            Homes[Finish_Home_2.X][Finish_Home_2.Y]=0x00;
            Homes[Finish_Home_3.X][Finish_Home_3.Y]=0x00;
            Homes[Finish_Home_4.X][Finish_Home_4.Y]=0x00;
            
            Home_Update2[0].Value = 0 ; Home_Update2[0].X_2 = Finish_Home_1.X ; Home_Update2[0].Y_2 = Finish_Home_1.Y ;
            Home_Update2[1].Value = 0 ; Home_Update2[1].X_2 = Finish_Home_2.X ; Home_Update2[1].Y_2 = Finish_Home_2.Y ;
            Home_Update2[2].Value = 0 ; Home_Update2[2].X_2 = Finish_Home_3.X ; Home_Update2[2].Y_2 = Finish_Home_3.Y ;
            Home_Update2[3].Value = 0 ; Home_Update2[3].X_2 = Finish_Home_4.X ; Home_Update2[3].Y_2 = Finish_Home_4.Y ;

            
			j = 3 ;
            for (i = 0 ; j < 255 ; i++)
            {
                 
                        And_x = N & Wall_Homes[Home_Update2[i].X_2][Home_Update2[i].Y_2] ;
                        if ( And_x == 0x00 )
                            if( Homes[Home_Update2[i].X_2][Home_Update2[i].Y_2 + 1] == 0xff )
                            {
                                j++ ;
                                Home_Update2[j].Value = Home_Update2[i].Value + 1 ;
                                Home_Update2[j].X_2 = Home_Update2[i].X_2 ;
                                Home_Update2[j].Y_2 = Home_Update2[i].Y_2 + 1 ; 
                                
                                Homes[Home_Update2[i].X_2][Home_Update2[i].Y_2 + 1] = Home_Update2[i].Value + 1 ;
                                
                            }
                        And_x = E & Wall_Homes[Home_Update2[i].X_2][Home_Update2[i].Y_2] ;
                        if ( And_x == 0x00 )
                            if( Homes[Home_Update2[i].X_2 + 1][Home_Update2[i].Y_2 ] == 0xff )
                            {
                                j++ ;
                                Home_Update2[j].Value = Home_Update2[i].Value + 1 ;
                                Home_Update2[j].X_2 = Home_Update2[i].X_2 + 1 ;
                                Home_Update2[j].Y_2 = Home_Update2[i].Y_2 ; 
                                
                                Homes[Home_Update2[i].X_2 + 1][Home_Update2[i].Y_2] = Home_Update2[i].Value + 1 ;
                                
                            }

                        And_x = S & Wall_Homes[Home_Update2[i].X_2][Home_Update2[i].Y_2] ;
                        if ( And_x == 0x00 )
                            if( Homes[Home_Update2[i].X_2][Home_Update2[i].Y_2 - 1] == 0xff )
                            {
                                j++ ;
                                Home_Update2[j].Value = Home_Update2[i].Value + 1 ;
                                Home_Update2[j].X_2 = Home_Update2[i].X_2 ;
                                Home_Update2[j].Y_2 = Home_Update2[i].Y_2 - 1 ; 
                                
                                Homes[Home_Update2[i].X_2][Home_Update2[i].Y_2 - 1] = Home_Update2[i].Value + 1 ;
                                
                            }
                        And_x = W & Wall_Homes[Home_Update2[i].X_2][Home_Update2[i].Y_2] ;
                        if ( And_x == 0x00 )
                            if( Homes[Home_Update2[i].X_2 - 1][Home_Update2[i].Y_2 ] == 0xff )
                            {
                                j++ ;
                                Home_Update2[j].Value = Home_Update2[i].Value + 1 ;
                                Home_Update2[j].X_2 = Home_Update2[i].X_2 - 1 ;
                                Home_Update2[j].Y_2 = Home_Update2[i].Y_2 ; 
                                
                                Homes[Home_Update2[i].X_2 - 1][Home_Update2[i].Y_2] = Home_Update2[i].Value + 1 ;
                                
                            } 

            }
//        LED_Update = 0 ;
    }
void Update_Ver2_1()
    {
        Lock();
//        LED_Update = 1;

        for (i=0; i<16;i++)
            for (j=0; j<16;j++)
                Homes[i][j]=0xff;
                
            Homes[Finish_Home_1.X][Finish_Home_1.Y]=0x00;
            Homes[Finish_Home_2.X][Finish_Home_2.Y]=0x00;
            Homes[Finish_Home_3.X][Finish_Home_3.Y]=0x00;
            Homes[Finish_Home_4.X][Finish_Home_4.Y]=0x00;
            
            Home_Update2[0].Value = 0 ; Home_Update2[0].X_2 = Finish_Home_1.X ; Home_Update2[0].Y_2 = Finish_Home_1.Y ;
            Home_Update2[1].Value = 0 ; Home_Update2[1].X_2 = Finish_Home_2.X ; Home_Update2[1].Y_2 = Finish_Home_2.Y ;
            Home_Update2[2].Value = 0 ; Home_Update2[2].X_2 = Finish_Home_3.X ; Home_Update2[2].Y_2 = Finish_Home_3.Y ;
            Home_Update2[3].Value = 0 ; Home_Update2[3].X_2 = Finish_Home_4.X ; Home_Update2[3].Y_2 = Finish_Home_4.Y ;

            j = 3 ;
			i = 0 ;
            while ( j < 255 && i < j )
            {
                 
                        And_x = N & Wall_Homes[Home_Update2[i].X_2][Home_Update2[i].Y_2] ;
                        if ( And_x == 0x00 )
                            if( Homes[Home_Update2[i].X_2][Home_Update2[i].Y_2 + 1] == 0xff )
                            {
                                j++ ;
                                Home_Update2[j].Value = Home_Update2[i].Value + 1 ;
                                Home_Update2[j].X_2 = Home_Update2[i].X_2 ;
                                Home_Update2[j].Y_2 = Home_Update2[i].Y_2 + 1 ; 
                                
                                Homes[Home_Update2[i].X_2][Home_Update2[i].Y_2 + 1] = Home_Update2[i].Value + 1 ;
                                
                            }
                        And_x = E & Wall_Homes[Home_Update2[i].X_2][Home_Update2[i].Y_2] ;
                        if ( And_x == 0x00 )
                            if( Homes[Home_Update2[i].X_2 + 1][Home_Update2[i].Y_2 ] == 0xff )
                            {
                                j++ ;
                                Home_Update2[j].Value = Home_Update2[i].Value + 1 ;
                                Home_Update2[j].X_2 = Home_Update2[i].X_2 + 1 ;
                                Home_Update2[j].Y_2 = Home_Update2[i].Y_2 ; 
                                
                                Homes[Home_Update2[i].X_2 + 1][Home_Update2[i].Y_2] = Home_Update2[i].Value + 1 ;
                                
                            }

                        And_x = S & Wall_Homes[Home_Update2[i].X_2][Home_Update2[i].Y_2] ;
                        if ( And_x == 0x00 )
                            if( Homes[Home_Update2[i].X_2][Home_Update2[i].Y_2 - 1] == 0xff )
                            {
                                j++ ;
                                Home_Update2[j].Value = Home_Update2[i].Value + 1 ;
                                Home_Update2[j].X_2 = Home_Update2[i].X_2 ;
                                Home_Update2[j].Y_2 = Home_Update2[i].Y_2 - 1 ; 
                                
                                Homes[Home_Update2[i].X_2][Home_Update2[i].Y_2 - 1] = Home_Update2[i].Value + 1 ;
                                
                            }
                        And_x = W & Wall_Homes[Home_Update2[i].X_2][Home_Update2[i].Y_2] ;
                        if ( And_x == 0x00 )
                            if( Homes[Home_Update2[i].X_2 - 1][Home_Update2[i].Y_2 ] == 0xff )
                            {
                                j++ ;
                                Home_Update2[j].Value = Home_Update2[i].Value + 1 ;
                                Home_Update2[j].X_2 = Home_Update2[i].X_2 - 1 ;
                                Home_Update2[j].Y_2 = Home_Update2[i].Y_2 ; 
                                
                                Homes[Home_Update2[i].X_2 - 1][Home_Update2[i].Y_2] = Home_Update2[i].Value + 1 ;
                                
                            } 

				i++;
            }
//        LED_Update = 0 ;
    }

void Update_Ver3()
    {
        Lock();
//        LED_Update = 1;

        for (i=0; i<16;i++)
            for (j=0; j<16;j++)
                Homes[i][j]=0xff;
                

		Homes[Finish_Home_1.X][Finish_Home_1.Y]=0x00;
            Homes[Finish_Home_2.X][Finish_Home_2.Y]=0x00;
            Homes[Finish_Home_3.X][Finish_Home_3.Y]=0x00;
            Homes[Finish_Home_4.X][Finish_Home_4.Y]=0x00;
            
            Home_Update3[0].Value = 0 ; Home_Update3[0].X_2 = Finish_Home_1.X ; Home_Update3[0].Y_2 = Finish_Home_1.Y ;
            Home_Update3[1].Value = 0 ; Home_Update3[1].X_2 = Finish_Home_2.X ; Home_Update3[1].Y_2 = Finish_Home_2.Y ;
            Home_Update3[2].Value = 0 ; Home_Update3[2].X_2 = Finish_Home_3.X ; Home_Update3[2].Y_2 = Finish_Home_3.Y ;
            Home_Update3[3].Value = 0 ; Home_Update3[3].X_2 = Finish_Home_4.X ; Home_Update3[3].Y_2 = Finish_Home_4.Y ;

            j = 3 ;
			l = 0 ;
            while ( j < 255 && l < j )
            {
						i = l % 58 ;
                        And_x = N & Wall_Homes[Home_Update3[i].X_2][Home_Update3[i].Y_2] ;
                        if ( And_x == 0x00 )
                            if( Homes[Home_Update3[i].X_2][Home_Update3[i].Y_2 + 1] == 0xff )
                            {
                                j++ ;
								k = j % 58 ;
                                Home_Update3[k].Value = Home_Update3[i].Value + 1 ;
                                Home_Update3[k].X_2 = Home_Update3[i].X_2 ;
                                Home_Update3[k].Y_2 = Home_Update3[i].Y_2 + 1 ; 
                      
                                Homes[Home_Update3[i].X_2][Home_Update3[i].Y_2 + 1] = Home_Update3[i].Value + 1 ;
                                
                            }
                        And_x = E & Wall_Homes[Home_Update3[i].X_2][Home_Update3[i].Y_2] ;
                        if ( And_x == 0x00 )
                            if( Homes[Home_Update3[i].X_2 + 1][Home_Update3[i].Y_2 ] == 0xff )
                            {
                                j++ ;
								k = j % 58 ;
                                Home_Update3[k].Value = Home_Update3[i].Value + 1 ;
                                Home_Update3[k].X_2 = Home_Update3[i].X_2 + 1 ;
                                Home_Update3[k].Y_2 = Home_Update3[i].Y_2 ; 
                                
                                Homes[Home_Update3[i].X_2 + 1][Home_Update3[i].Y_2] = Home_Update3[i].Value + 1 ;
                                
                            }

                        And_x = S & Wall_Homes[Home_Update3[i].X_2][Home_Update3[i].Y_2] ;
                        if ( And_x == 0x00 )
                            if( Homes[Home_Update3[i].X_2][Home_Update3[i].Y_2 - 1] == 0xff )
                            {
                                j++ ;
								k = j % 58 ;
                                Home_Update3[k].Value = Home_Update3[i].Value + 1 ;
                                Home_Update3[k].X_2 = Home_Update3[i].X_2 ;
                                Home_Update3[k].Y_2 = Home_Update3[i].Y_2 - 1 ; 
                                
                                Homes[Home_Update3[i].X_2][Home_Update3[i].Y_2 - 1] = Home_Update3[i].Value + 1 ;
                                
                            }
                        And_x = W & Wall_Homes[Home_Update3[i].X_2][Home_Update3[i].Y_2] ;
                        if ( And_x == 0x00 )
                            if( Homes[Home_Update3[i].X_2 - 1][Home_Update3[i].Y_2 ] == 0xff )
                            {
                                j++ ;
								k = j % 58 ;
                                Home_Update3[k].Value = Home_Update3[i].Value + 1 ;
                                Home_Update3[k].X_2 = Home_Update3[i].X_2 - 1 ;
                                Home_Update3[k].Y_2 = Home_Update3[i].Y_2 ; 
                                
                                Homes[Home_Update3[i].X_2 - 1][Home_Update3[i].Y_2] = Home_Update3[i].Value + 1 ;
                                
                            } 

				l++;
            }
//        LED_Update = 0 ;
    }
*/
void Move_Robot_Speed()
{
        //char And;
        //Wall_Homes[Index_Robot.X][Index_Robot.Y] |= RPT;   //          
        while ( Angle_Robot == N )
        {
            And = N;      //      North
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1] )
            {
                Index_Robot.Y = Index_Robot.Y + 1;
                Darage(N);
                return ;
            }
            And = E;      //      East
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y] )
            {
                Index_Robot.X = Index_Robot.X + 1;
                Darage(E);
                return ;
            }
            And = W;      //      West
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y] )
            {
                Index_Robot.X = Index_Robot.X - 1;
                Darage(W);
                return ;
            }
            And = S;      //      South
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1] )
            {
                Index_Robot.Y = Index_Robot.Y - 1;
                Darage(S);
                return ;
            }
            Update();
        }
        while (Angle_Robot == E)
        {
            And = E;      //      East
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y] )
            {
                Index_Robot.X = Index_Robot.X + 1;
                Darage(E);
                return ;
            }
            And = N;      //      North
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1] )
            {
                Index_Robot.Y = Index_Robot.Y + 1;
                Darage(N);
                return ;
            }
            And = W;      //      West
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y] )
            {
                Index_Robot.X = Index_Robot.X - 1;
                Darage(W);
                return ;
            }
            And = S;      //      South
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1] )
            {
                Index_Robot.Y = Index_Robot.Y - 1;
                Darage(S);
                return ;
            }
            Update();
        }
        while (Angle_Robot == W)
        {
            And = W;      //      West
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y] )
            {
                Index_Robot.X = Index_Robot.X - 1;
                Darage(W);
                return ;
            }
            And = N;      //      North
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1] )
            {
                Index_Robot.Y = Index_Robot.Y + 1;
                Darage(N);
                return ;
            }
            And = E;      //      East
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y] )
            {
                Index_Robot.X = Index_Robot.X + 1;
                Darage(E);
                return ;
            }
            And = S;      //      South
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1] )
            {
                Index_Robot.Y = Index_Robot.Y - 1;
                Darage(S);
                return ;
            }
            Update();
        }
        while (Angle_Robot == S)
        {
            And = S;      //      South
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1] )
            {
                Index_Robot.Y = Index_Robot.Y - 1;
                Darage(S);
                return ;
            }
            And = E;      //      East
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y] )
            {
                Index_Robot.X = Index_Robot.X + 1;
                Darage(E);
                return ;
            }
            And = N;      //      North
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1] )
            {
                Index_Robot.Y = Index_Robot.Y + 1;
                Darage(N);
                return ;
            }
            And = W;      //      West
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y] )
            {
                Index_Robot.X = Index_Robot.X - 1;
                Darage(W);
                return ;
            }
            Update();
        }
        Wall_Homes[Index_Robot.X][Index_Robot.Y] = Wall_Homes[Index_Robot.X][Index_Robot.Y] | RPT;   //          
}
void Move_Robot_Speed_RPT()
{
//        char And;
        Wall_Homes[Index_Robot.X][Index_Robot.Y] |= RPT;   //          
        while ( Angle_Robot == N )
        {
            
            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1]) && ( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y + 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return ;
                }
            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y]) && ( RPT & Wall_Homes[Index_Robot.X + 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return ;
                }
            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y] )&& ( RPT & Wall_Homes[Index_Robot.X - 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return ;
                }
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00) 
                if (( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1]) && ( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y - 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return ;
                }
                

            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1])
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return ;
                }

            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y])
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return ;
                }
            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y])
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return ;
                }
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1])
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return ;
                }
            
            Update();
        }
        while (Angle_Robot == E)
        {

            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y]) && ( RPT & Wall_Homes[Index_Robot.X + 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return ;
                }
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00) 
                if (( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1]) && ( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y - 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return ;
                }
            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1]) && ( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y + 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return ;
                }                
            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y] )&& ( RPT & Wall_Homes[Index_Robot.X - 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return ;
                }

            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y])
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return ;
                }
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1])
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return ;
                }
            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1])
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return ;
                }
            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y])
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return ;
                }
                
            Update();
        }
        while (Angle_Robot == W)
        {

            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y] )&& ( RPT & Wall_Homes[Index_Robot.X - 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return ;
                }
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00) 
                if (( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1]) && ( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y - 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return ;
                }
            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1]) && ( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y + 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return ;
                }                
            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y]) && ( RPT & Wall_Homes[Index_Robot.X + 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return ;
                }
                
            
            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y])
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return ;
                }
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1])
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return ;
                }
            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1])
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return ;
                }
            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y])
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return ;
                }
            Update();
        }
        while (Angle_Robot == S)
        {
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00) 
                if (( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1]) && ( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y - 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return ;
                }
            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1]) && ( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y + 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return ;
                }                
            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y]) && ( RPT & Wall_Homes[Index_Robot.X + 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return ;
                }
            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y] )&& ( RPT & Wall_Homes[Index_Robot.X - 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return ;
                }
                
            
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1])
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return ;
                }
            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1])
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return ;
                }
            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y])
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return ;
                }
            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y])
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return ;
                }

            Update();
        }
        Wall_Homes[Index_Robot.X][Index_Robot.Y] = Wall_Homes[Index_Robot.X][Index_Robot.Y] | RPT;   //          
}

void Move_Robot_Speed_RPT_NO_Update()
{
//        char And;
        Wall_Homes[Index_Robot.X][Index_Robot.Y] |= RPT;   //          
        while ( Angle_Robot == N )
        {
            
            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1]) || ( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y + 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return ;
                }
            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y]) || ( RPT & Wall_Homes[Index_Robot.X + 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return ;
                }
            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y] ) || ( RPT & Wall_Homes[Index_Robot.X - 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return ;
                }
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00) 
                if (( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1]) || ( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y - 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return ;
                }
                   
            Update();
        }
        while (Angle_Robot == E)
        {

            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y]) || ( RPT & Wall_Homes[Index_Robot.X + 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return ;
                }
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00) 
                if (( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1]) || ( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y - 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return ;
                }
            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1]) || ( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y + 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return ;
                }                
            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y]) || ( RPT & Wall_Homes[Index_Robot.X - 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return ;
                }

            Update();
        }
        while (Angle_Robot == W)
        {

            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y] ) || ( RPT & Wall_Homes[Index_Robot.X - 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return ;
                }
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00) 
                if (( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1]) || ( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y - 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return ;
                }
            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1]) || ( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y + 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return ;
                }                
            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y]) || ( RPT & Wall_Homes[Index_Robot.X + 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return ;
                }
                
            Update();
        }
        while (Angle_Robot == S)
        {
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00) 
                if (( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1]) || ( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y - 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return ;
                }
            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1]) || ( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y + 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return ;
                }                
            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y]) || ( RPT & Wall_Homes[Index_Robot.X + 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return ;
                }
            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y]) || ( RPT & Wall_Homes[Index_Robot.X - 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return ;
                }

            Update();
        }
        Wall_Homes[Index_Robot.X][Index_Robot.Y] = Wall_Homes[Index_Robot.X][Index_Robot.Y] | RPT;   //          
}
void Move_Robot_Speed_RPT_NO_Update_Ver2()
{
//        char And;
        Wall_Homes[Index_Robot.X][Index_Robot.Y] |= RPT;   //          
        while ( Angle_Robot == N )
        {
            
            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1]) 
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return ;
                }
            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y])
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return ;
                }
            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y])
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return ;
                }
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00) 
                if ( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1])
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return ;
                }

            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if (( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y + 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return ;
                }
            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if (( RPT & Wall_Homes[Index_Robot.X + 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return ;
                }
            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if (( RPT & Wall_Homes[Index_Robot.X - 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return ;
                }
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00) 
                if (( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y - 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return ;
                }

            Update();
        }
        while (Angle_Robot == E)
        {

            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y])
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return ;
                }
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00) 
                if ( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1])
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return ;
                }
            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1])
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return ;
                }                
            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y])
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return ;
                }


            
            
            
            
            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if (( RPT & Wall_Homes[Index_Robot.X + 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return ;
                }
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00) 
                if ((RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y - 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return ;
                }
            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if ((RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y + 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return ;
                }                
            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ((RPT & Wall_Homes[Index_Robot.X - 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return ;
                }



            Update();
        }
        while (Angle_Robot == W)
        {

            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y] )
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return ;
                }
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00) 
                if ( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1])
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return ;
                }
            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1])
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return ;
                }                
            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y])
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return ;
                }
            
            
            
            
            
            
            
            
            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if (( RPT & Wall_Homes[Index_Robot.X - 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return ;
                }
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00) 
                if (( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y - 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return ;
                }
            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if (( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y + 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return ;
                }                
            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if (( RPT & Wall_Homes[Index_Robot.X + 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return ;
                }
            
            
            
            
            
            
            
            
                
            Update();
        }
        while (Angle_Robot == S)
        {
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00) 
                if ( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1]) 
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return ;
                }
            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1]) 
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return ;
                }                
            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y]) 
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return ;
                }
            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y]) 
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return ;
                }







            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00) 
                if ( ( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y - 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return ;
                }
            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if ( ( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y + 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return ;
                }                
            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if (( RPT & Wall_Homes[Index_Robot.X + 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return ;
                }
            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if (( RPT & Wall_Homes[Index_Robot.X - 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return ;
                }











            Update();
        }
        Wall_Homes[Index_Robot.X][Index_Robot.Y] = Wall_Homes[Index_Robot.X][Index_Robot.Y] | RPT;   //          
}


char Move_Robot()
    {
        Wall_Homes[Index_Robot.X][Index_Robot.Y] |= RPT;   //          
            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1])
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return 0;
                }

            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y])
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return 0;
                }
            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y])
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return 0;
                }
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1])
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return 0;
                }
            return 1;


    } 
char Move_Robot_RPT()
    {
        Wall_Homes[Index_Robot.X][Index_Robot.Y] |= RPT;   //          
            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1]) && ( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y + 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return 0;
                }
            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y]) && ( RPT & Wall_Homes[Index_Robot.X + 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return 0;
                }
            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ((Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y] )&& ( RPT & Wall_Homes[Index_Robot.X - 1][Index_Robot.Y]) == 0x00 )
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return 0;
                }
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00) 
                if (( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1]) && ( RPT & Wall_Homes[Index_Robot.X][Index_Robot.Y - 1]) == 0x00 )
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return 0;
                }
                

            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1])
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return 0;
                }

            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y])
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return 0;
                }
            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y])
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return 0;
                }
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1])
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return 0;
                }
            return 1;


    }  
char Move_Robot_Arc()
    {
        char And;
        Wall_Homes[Index_Robot.X][Index_Robot.Y] |= RPT;   //          
        while (1)
        {
            And = N;      //      North
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1] )
            {
                        And = N;      //      North
                        And &= Wall_Homes[Index_Robot.X][Index_Robot.Y + 1];
                        if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y + 1] > Homes[Index_Robot.X][Index_Robot.Y + 2] )
                        {
                            Angle_Move_Robot_First = N ;
                            Angle_Move_Robot_Second = N;
                            Index_Robot.Y = Index_Robot.Y + 1;
                            return 0;
                        }
                        else
                        {
                            And = E;      //      East
                            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y + 1];
                            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y + 1] > Homes[Index_Robot.X + 1][Index_Robot.Y + 1] )
                            {
                                Angle_Move_Robot_First = N ;
                                Angle_Move_Robot_Second = E ;
                                Index_Robot.Y = Index_Robot.Y + 1;
                                return 1;
                            }
                            And = W;      //      West
                            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y + 1];
                            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y + 1] > Homes[Index_Robot.X - 1][Index_Robot.Y + 1] )
                            {
                                Angle_Move_Robot_First = N ;
                                Angle_Move_Robot_Second = W ;

                                Index_Robot.Y = Index_Robot.Y + 1;
                                return 1;
                            }
                        }
            }
            And = E;      //      East
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y] )
            {
                        And = E;      //      East
                        And &= Wall_Homes[Index_Robot.X + 1][Index_Robot.Y];
                        if ( And == 0x00 && Homes[Index_Robot.X + 1][Index_Robot.Y] > Homes[Index_Robot.X + 2][Index_Robot.Y] )
                        {
                                Angle_Move_Robot_First = E ;
                                Angle_Move_Robot_Second = E ;
                                Index_Robot.X = Index_Robot.X + 1;
                            return 0;
                        }
                        else
                        {
                            And = N;      //      North
                            And &= Wall_Homes[Index_Robot.X + 1][Index_Robot.Y];
                            if ( And == 0x00 && Homes[Index_Robot.X + 1][Index_Robot.Y] > Homes[Index_Robot.X + 1][Index_Robot.Y + 1] )
                            {
                                Angle_Move_Robot_First = E ;
                                Angle_Move_Robot_Second = N ;

                                Index_Robot.X = Index_Robot.X + 1;
                                return 1;
                            }
                            And = S;      //      South
                            And &= Wall_Homes[Index_Robot.X + 1][Index_Robot.Y];
                            if ( And == 0x00 && Homes[Index_Robot.X + 1][Index_Robot.Y] > Homes[Index_Robot.X + 1][Index_Robot.Y - 1] )
                            {
                                Angle_Move_Robot_First = E ;
                                Angle_Move_Robot_Second = S ;

                                Index_Robot.X = Index_Robot.X + 1;
                                return 1;
                            }
                        }
            }
            And = W;      //      West
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y] )
            {
                        And = W;        //      West
                        And &= Wall_Homes[Index_Robot.X - 1][Index_Robot.Y];
                        if ( And == 0x00 && Homes[Index_Robot.X - 1][Index_Robot.Y] > Homes[Index_Robot.X - 2][Index_Robot.Y] )
                        {

                                Angle_Move_Robot_First = W ;
                                Angle_Move_Robot_Second = W ;
                            Index_Robot.X = Index_Robot.X - 1;
                            return 0;
                        }
                        else
                        {
                            And = N;      //      North
                            And &= Wall_Homes[Index_Robot.X - 1][Index_Robot.Y];
                            if ( And == 0x00 && Homes[Index_Robot.X - 1][Index_Robot.Y] > Homes[Index_Robot.X - 1][Index_Robot.Y + 1] )
                            {
                                Angle_Move_Robot_First = W ;
                                Angle_Move_Robot_Second = N ;
                                Index_Robot.X = Index_Robot.X - 1;
                                return 1;
                            }
                            And = S;      //      South
                            And &= Wall_Homes[Index_Robot.X - 1][Index_Robot.Y];
                            if ( And == 0x00 && Homes[Index_Robot.X - 1][Index_Robot.Y] > Homes[Index_Robot.X - 1][Index_Robot.Y - 1] )
                            {
                                Angle_Move_Robot_First = W ;
                                Angle_Move_Robot_Second = S ;
                                Index_Robot.X = Index_Robot.X - 1;
                                return 1;
                            }
                        }
            }
            And = S;      //      South
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1] )
            {
                        And = S;      //      South
                        And &= Wall_Homes[Index_Robot.X][Index_Robot.Y - 1];
                        if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y - 1] > Homes[Index_Robot.X][Index_Robot.Y - 2] )
                        {
                                Angle_Move_Robot_First = S ;
                                Angle_Move_Robot_Second = S ;

                            Index_Robot.Y = Index_Robot.Y - 1;
                            return 0;
                        }
                        else
                        {
                            And = E;      //      East
                            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y - 1];
                            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y - 1] > Homes[Index_Robot.X + 1][Index_Robot.Y - 1] )
                            {
                                Angle_Move_Robot_First = S ;
                                Angle_Move_Robot_Second = E ;

                                Index_Robot.Y = Index_Robot.Y - 1;
                                return 1;
                            }
                            And = W;      //      West
                            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y - 1];
                            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y - 1] > Homes[Index_Robot.X - 1][Index_Robot.Y - 1] )
                            {
                                Angle_Move_Robot_First = S ;
                                Angle_Move_Robot_Second = W ;

                                Index_Robot.Y = Index_Robot.Y - 1;
                                return 1;
                            }
                        }
            }
            Update();
        }
    }
void Go_To_Center_Point(void)
{
    if ( Index_Robot_Point == Point_Up ) Darage(S);
    else if ( Index_Robot_Point == Point_Down ) Darage(N);
    else if ( Index_Robot_Point == Point_Right ) Darage(W);
    else if ( Index_Robot_Point == Point_Left ) Darage(E);

    Front_Half_Size_Home();
    Index_Robot_Point = Point_Center ;     
}
void Finish()
    {
        if (Index_Robot.X == Finish_Home_1.X || Index_Robot.X == Finish_Home_2.X ||Index_Robot.X == Finish_Home_3.X || Index_Robot.X == Finish_Home_4.X)
        if (Index_Robot.Y == Finish_Home_1.Y || Index_Robot.Y == Finish_Home_2.Y ||Index_Robot.Y == Finish_Home_3.Y || Index_Robot.Y == Finish_Home_4.Y)
        {
            if (Model_Move == On_ALG) Go_To_Center_Point();
            Save ();
            
            if (Check_Home_Finish == On_ALG) 
                if (Back_Way == 5) 
                    Back_Way = 0;
                else 
                    Back_Way = 5;                                                                                                 
            else 
            {
                Back_Way ++ ;
                if (Index_Robot.X == 7 && Index_Robot.Y == 7)Back_Way = 2 ;
            }


            if (Len_Way_A != Len_Way)
            {
                Len_Way_A = Len_Way ;
                Small_Len_Way = Off_ALG;
            }
            else Small_Len_Way = On_ALG;
    
            Len_Way = 0;     
        
            if (Back_Way == 6) 
            {
                    
                Back_Way = 0;
            }
    
            if (Back_Way == 0)
            {
                Finish_Home_1.X =7;Finish_Home_1.Y =7;
                Finish_Home_2.X =8;Finish_Home_2.Y =7;
                Finish_Home_3.X =7;Finish_Home_3.Y =8;
                Finish_Home_4.X =8;Finish_Home_4.Y =8;
            }
            else if (Back_Way == 1 )
            {
                Finish_Home_1.X =7;Finish_Home_1.Y =7;
                Finish_Home_2.X =7;Finish_Home_2.Y =7;
                Finish_Home_3.X =7;Finish_Home_3.Y =7;
                Finish_Home_4.X =7;Finish_Home_4.Y =7;
            }
            else if (Back_Way == 2 )
            {
                Finish_Home_1.X =7;Finish_Home_1.Y =8;
                Finish_Home_2.X =7;Finish_Home_2.Y =8;
                Finish_Home_3.X =7;Finish_Home_3.Y =8;
                Finish_Home_4.X =7;Finish_Home_4.Y =8;
            }
            else if (Back_Way == 3 )
            {
                Finish_Home_1.X =8;Finish_Home_1.Y =8;
                Finish_Home_2.X =8;Finish_Home_2.Y =8;
                Finish_Home_3.X =8;Finish_Home_3.Y =8;
                Finish_Home_4.X =8;Finish_Home_4.Y =8;
            }
            else if (Back_Way == 4 )
            {
                Finish_Home_1.X =8;Finish_Home_1.Y =7;
                Finish_Home_2.X =8;Finish_Home_2.Y =7;
                Finish_Home_3.X =8;Finish_Home_3.Y =7;
                Finish_Home_4.X =8;Finish_Home_4.Y =7;
            }
            else if (Back_Way == 5 )
            {
                Finish_Home_1.X =0;Finish_Home_1.Y =0;
                Finish_Home_2.X =0;Finish_Home_2.Y =0;
                Finish_Home_3.X =0;Finish_Home_3.Y =0;
                Finish_Home_4.X =0;Finish_Home_4.Y =0;
                Check_Home_Finish = On_ALG; 
            }     
            Update();

        }
        
    }
void Finish_RPT()
    {
    char Counter_i,Counter_j;
        if (Index_Robot.X == Finish_Home_1.X || Index_Robot.X == Finish_Home_2.X ||Index_Robot.X == Finish_Home_3.X || Index_Robot.X == Finish_Home_4.X)
        if (Index_Robot.Y == Finish_Home_1.Y || Index_Robot.Y == Finish_Home_2.Y ||Index_Robot.Y == Finish_Home_3.Y || Index_Robot.Y == Finish_Home_4.Y)
        {
            if (Model_Move == On_ALG) Go_To_Center_Point();
            Save ();
            
            if (Check_Home_Finish == On_ALG) 
                if (Back_Way == 5) 
                    Back_Way = 0;
                else 
                    Back_Way = 5;                                                                                                 
            else 
            {
                Back_Way ++ ;
                if (Index_Robot.X == 7 && Index_Robot.Y == 7)Back_Way = 2 ;
            }


            if (Len_Way_A != Len_Way)
            {
                Len_Way_A = Len_Way ;
                Small_Len_Way = Off_ALG;
            }
            else Small_Len_Way = On_ALG;
    
            Len_Way = 0;     
        
            if (Back_Way == 6) 
            {
                    
                Back_Way = 0;
            }
    
            if (Back_Way == 0)
            {
                Finish_Home_1.X =7;Finish_Home_1.Y =7;
                Finish_Home_2.X =8;Finish_Home_2.Y =7;
                Finish_Home_3.X =7;Finish_Home_3.Y =8;
                Finish_Home_4.X =8;Finish_Home_4.Y =8;
            }
            else if (Back_Way == 1 )
            {
                Finish_Home_1.X =7;Finish_Home_1.Y =7;
                Finish_Home_2.X =7;Finish_Home_2.Y =7;
                Finish_Home_3.X =7;Finish_Home_3.Y =7;
                Finish_Home_4.X =7;Finish_Home_4.Y =7;
            }
            else if (Back_Way == 2 )
            {
                Finish_Home_1.X =7;Finish_Home_1.Y =8;
                Finish_Home_2.X =7;Finish_Home_2.Y =8;
                Finish_Home_3.X =7;Finish_Home_3.Y =8;
                Finish_Home_4.X =7;Finish_Home_4.Y =8;
            }
            else if (Back_Way == 3 )
            {
                Finish_Home_1.X =8;Finish_Home_1.Y =8;
                Finish_Home_2.X =8;Finish_Home_2.Y =8;
                Finish_Home_3.X =8;Finish_Home_3.Y =8;
                Finish_Home_4.X =8;Finish_Home_4.Y =8;
            }
            else if (Back_Way == 4 )
            {
                Finish_Home_1.X =8;Finish_Home_1.Y =7;
                Finish_Home_2.X =8;Finish_Home_2.Y =7;
                Finish_Home_3.X =8;Finish_Home_3.Y =7;
                Finish_Home_4.X =8;Finish_Home_4.Y =7;
            }
            else if (Back_Way == 5 )
            {
                Finish_Home_1.X =0;Finish_Home_1.Y =0;
                Finish_Home_2.X =0;Finish_Home_2.Y =0;
                Finish_Home_3.X =0;Finish_Home_3.Y =0;
                Finish_Home_4.X =0;Finish_Home_4.Y =0;
                
                for (Counter_i=16; Counter_i>0;Counter_i--)
                {
                    for (Counter_j=16; Counter_j>0;Counter_j--)
                    {    
                        if ((Wall_Homes[Counter_i-1][Counter_j-1] & RPT)==0x00)
                        {
                            Finish_Home_1.X=Counter_i-1;Finish_Home_1.Y=Counter_j-1;                        
                            Finish_Home_2.X=Counter_i-1;Finish_Home_2.Y=Counter_j-1;                        
                            Finish_Home_3.X=Counter_i-1;Finish_Home_3.Y=Counter_j-1;                        
                            Finish_Home_4.X=Counter_i-1;Finish_Home_4.Y=Counter_j-1;                        
                            //Back_Way = 0;
                        }   
                        //lcd_gotoxy(0,3);
                        //sprintf(buffer,"X%d Y%d i%d j%d wall %d ",Finish_Home_1.X,Finish_Home_1.Y,Counter_i-1,Counter_j-1,Wall_Homes[Counter_i-1][Counter_j-1]);
                        //lcd_puts(buffer);
                    }
                }
                
                Check_Home_Finish = On_ALG;
            }
     
            Update();
        }
        
    }
/*
void Move_Robot()         //   ј      捘    Ԙ    
    {
        char And;
        //Wall_Homes[Index_Robot.X][Index_Robot.Y] |= RPT;   //          
        while (1)
        {
            And = N;      //      North
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1] )
            {
                Index_Robot.Y = Index_Robot.Y + 1;
                Darage(N);
                return ;
            }
            And = E;      //      East
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y] )
            {
                Index_Robot.X = Index_Robot.X + 1;
                Darage(E);
                return ;
            }
            And = W;      //      West
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y] )
            {
                Index_Robot.X = Index_Robot.X - 1;
                Darage(W);
                return ;
            }
            And = S;      //      South
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1] )
            {
                Index_Robot.Y = Index_Robot.Y - 1;
                Darage(S);
                return ;
            }
            Update();
        }
    }
char Move_Robot_Arc()     //   ј      捘    Ԙ          
    {
        char And;
        //Wall_Homes[Index_Robot.X][Index_Robot.Y] |= RPT;   //          
        while (1)
        {
            And = N;      //      North
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1] )
            {
                        And = N;      //      North
                        And &= Wall_Homes[Index_Robot.X][Index_Robot.Y + 1];
                        if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y + 1] > Homes[Index_Robot.X][Index_Robot.Y + 2] )
                        {
                            Angle_Move_Robot_First = N ;
                            Angle_Move_Robot_Second = N;
                            Index_Robot.Y = Index_Robot.Y + 1;
                            return 0;
                        }
                        else
                        {
                            And = E;      //      East
                            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y + 1];
                            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y + 1] > Homes[Index_Robot.X + 1][Index_Robot.Y + 1] )
                            {
                                Angle_Move_Robot_First = N ;
                                Angle_Move_Robot_Second = E ;
                                Index_Robot.Y = Index_Robot.Y + 1;
                                return 1;
                            }
                            And = W;      //      West
                            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y + 1];
                            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y + 1] > Homes[Index_Robot.X - 1][Index_Robot.Y + 1] )
                            {
                                Angle_Move_Robot_First = N ;
                                Angle_Move_Robot_Second = W ;

                                Index_Robot.Y = Index_Robot.Y + 1;
                                return 1;
                            }
                        }
            }
            And = E;      //      East
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y] )
            {
                        And = E;      //      East
                        And &= Wall_Homes[Index_Robot.X + 1][Index_Robot.Y];
                        if ( And == 0x00 && Homes[Index_Robot.X + 1][Index_Robot.Y] > Homes[Index_Robot.X + 2][Index_Robot.Y] )
                        {
                                Angle_Move_Robot_First = E ;
                                Angle_Move_Robot_Second = E ;
                                Index_Robot.X = Index_Robot.X + 1;
                            return 0;
                        }
                        else
                        {
                            And = N;      //      North
                            And &= Wall_Homes[Index_Robot.X + 1][Index_Robot.Y];
                            if ( And == 0x00 && Homes[Index_Robot.X + 1][Index_Robot.Y] > Homes[Index_Robot.X + 1][Index_Robot.Y + 1] )
                            {
                                Angle_Move_Robot_First = E ;
                                Angle_Move_Robot_Second = N ;

                                Index_Robot.X = Index_Robot.X + 1;
                                return 1;
                            }
                            And = S;      //      South
                            And &= Wall_Homes[Index_Robot.X + 1][Index_Robot.Y];
                            if ( And == 0x00 && Homes[Index_Robot.X + 1][Index_Robot.Y] > Homes[Index_Robot.X + 1][Index_Robot.Y - 1] )
                            {
                                Angle_Move_Robot_First = E ;
                                Angle_Move_Robot_Second = S ;

                                Index_Robot.X = Index_Robot.X + 1;
                                return 1;
                            }
                        }
            }
            And = W;      //      West
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y] )
            {
                        And = W;        //      West
                        And &= Wall_Homes[Index_Robot.X - 1][Index_Robot.Y];
                        if ( And == 0x00 && Homes[Index_Robot.X - 1][Index_Robot.Y] > Homes[Index_Robot.X - 2][Index_Robot.Y] )
                        {

                                Angle_Move_Robot_First = W ;
                                Angle_Move_Robot_Second = W ;
                            Index_Robot.X = Index_Robot.X - 1;
                            return 0;
                        }
                        else
                        {
                            And = N;      //      North
                            And &= Wall_Homes[Index_Robot.X - 1][Index_Robot.Y];
                            if ( And == 0x00 && Homes[Index_Robot.X - 1][Index_Robot.Y] > Homes[Index_Robot.X - 1][Index_Robot.Y + 1] )
                            {
                                Angle_Move_Robot_First = W ;
                                Angle_Move_Robot_Second = N ;
                                Index_Robot.X = Index_Robot.X - 1;
                                return 1;
                            }
                            And = S;      //      South
                            And &= Wall_Homes[Index_Robot.X - 1][Index_Robot.Y];
                            if ( And == 0x00 && Homes[Index_Robot.X - 1][Index_Robot.Y] > Homes[Index_Robot.X - 1][Index_Robot.Y - 1] )
                            {
                                Angle_Move_Robot_First = W ;
                                Angle_Move_Robot_Second = S ;
                                Index_Robot.X = Index_Robot.X - 1;
                                return 1;
                            }
                        }
            }
            And = S;      //      South
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1] )
            {
                        And = S;      //      South
                        And &= Wall_Homes[Index_Robot.X][Index_Robot.Y - 1];
                        if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y - 1] > Homes[Index_Robot.X][Index_Robot.Y - 2] )
                        {
                                Angle_Move_Robot_First = S ;
                                Angle_Move_Robot_Second = S ;

                            Index_Robot.Y = Index_Robot.Y - 1;
                            return 0;
                        }
                        else
                        {
                            And = E;      //      East
                            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y - 1];
                            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y - 1] > Homes[Index_Robot.X + 1][Index_Robot.Y - 1] )
                            {
                                Angle_Move_Robot_First = S ;
                                Angle_Move_Robot_Second = E ;

                                Index_Robot.Y = Index_Robot.Y - 1;
                                return 1;
                            }
                            And = W;      //      West
                            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y - 1];
                            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y - 1] > Homes[Index_Robot.X - 1][Index_Robot.Y - 1] )
                            {
                                Angle_Move_Robot_First = S ;
                                Angle_Move_Robot_Second = W ;

                                Index_Robot.Y = Index_Robot.Y - 1;
                                return 1;
                            }
                        }
            }
            Update();
        }
    }
*/
char Move_Robot_45()            //   ј      捘    Ԙ        ј 45 
    {
        char And;
        //Wall_Homes[Index_Robot.X][Index_Robot.Y] |= RPT;   //          
        while (1)
        {
            And = N;      //      North
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1] )
            {
                        And = N;      //      North
                        And &= Wall_Homes[Index_Robot.X][Index_Robot.Y + 1];
                        if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y + 1] > Homes[Index_Robot.X][Index_Robot.Y + 2] )
                        {
                            Angle_Move_Robot_First = N ;
                            Angle_Move_Robot_Second = N;
                            Index_Robot.Y = Index_Robot.Y + 1;
                            return 0;
                        }
                        else
                        {
                            And = E;      //      East
                            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y + 1];
                            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y + 1] > Homes[Index_Robot.X + 1][Index_Robot.Y + 1] )
                            {
                                Angle_Move_Robot_First = N ;
                                Angle_Move_Robot_Second = NE ;
                                Index_Robot.Y = Index_Robot.Y + 1;
                                return 1;
                            }
                            And = W;      //      West
                            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y + 1];
                            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y + 1] > Homes[Index_Robot.X - 1][Index_Robot.Y + 1] )
                            {
                                Angle_Move_Robot_First = N ;
                                Angle_Move_Robot_Second = NW ;

                                Index_Robot.Y = Index_Robot.Y + 1;
                                return 1;
                            }
                        }
            }
            And = E;      //      East
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y] )
            {
                        And = E;      //      East
                        And &= Wall_Homes[Index_Robot.X + 1][Index_Robot.Y];
                        if ( And == 0x00 && Homes[Index_Robot.X + 1][Index_Robot.Y] > Homes[Index_Robot.X + 2][Index_Robot.Y] )
                        {
                                Angle_Move_Robot_First = E ;
                                Angle_Move_Robot_Second = E ;
                                Index_Robot.X = Index_Robot.X + 1;
                            return 0;
                        }
                        else
                        {
                            And = N;      //      North
                            And &= Wall_Homes[Index_Robot.X + 1][Index_Robot.Y];
                            if ( And == 0x00 && Homes[Index_Robot.X + 1][Index_Robot.Y] > Homes[Index_Robot.X + 1][Index_Robot.Y + 1] )
                            {
                                Angle_Move_Robot_First = E ;
                                Angle_Move_Robot_Second = NE ;

                                Index_Robot.X = Index_Robot.X + 1;
                                return 1;
                            }
                            And = S;      //      South
                            And &= Wall_Homes[Index_Robot.X + 1][Index_Robot.Y];
                            if ( And == 0x00 && Homes[Index_Robot.X + 1][Index_Robot.Y] > Homes[Index_Robot.X + 1][Index_Robot.Y - 1] )
                            {
                                Angle_Move_Robot_First = E ;
                                Angle_Move_Robot_Second = SE1 ;

                                Index_Robot.X = Index_Robot.X + 1;
                                return 1;
                            }
                        }
            }
            And = W;      //      West
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y] )
            {
                        And = W;        //      West
                        And &= Wall_Homes[Index_Robot.X - 1][Index_Robot.Y];
                        if ( And == 0x00 && Homes[Index_Robot.X - 1][Index_Robot.Y] > Homes[Index_Robot.X - 2][Index_Robot.Y] )
                        {

                                Angle_Move_Robot_First = W ;
                                Angle_Move_Robot_Second = W ;
                            Index_Robot.X = Index_Robot.X - 1;
                            return 0;
                        }
                        else
                        {
                            And = N;      //      North
                            And &= Wall_Homes[Index_Robot.X - 1][Index_Robot.Y];
                            if ( And == 0x00 && Homes[Index_Robot.X - 1][Index_Robot.Y] > Homes[Index_Robot.X - 1][Index_Robot.Y + 1] )
                            {
                                Angle_Move_Robot_First = W ;
                                Angle_Move_Robot_Second = NW ;
                                Index_Robot.X = Index_Robot.X - 1;
                                return 1;
                            }
                            And = S;      //      South
                            And &= Wall_Homes[Index_Robot.X - 1][Index_Robot.Y];
                            if ( And == 0x00 && Homes[Index_Robot.X - 1][Index_Robot.Y] > Homes[Index_Robot.X - 1][Index_Robot.Y - 1] )
                            {
                                Angle_Move_Robot_First = W ;
                                Angle_Move_Robot_Second = SW ;
                                Index_Robot.X = Index_Robot.X - 1;
                                return 1;
                            }
                        }
            }
            And = S;      //      South
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1] )
            {
                        And = S;      //      South
                        And &= Wall_Homes[Index_Robot.X][Index_Robot.Y - 1];
                        if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y - 1] > Homes[Index_Robot.X][Index_Robot.Y - 2] )
                        {
                                Angle_Move_Robot_First = S ;
                                Angle_Move_Robot_Second = S ;

                            Index_Robot.Y = Index_Robot.Y - 1;
                            return 0;
                        }
                        else
                        {
                            And = E;      //      East
                            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y - 1];
                            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y - 1] > Homes[Index_Robot.X + 1][Index_Robot.Y - 1] )
                            {
                                Angle_Move_Robot_First = S ;
                                Angle_Move_Robot_Second = SE1 ;

                                Index_Robot.Y = Index_Robot.Y - 1;
                                return 1;
                            }
                            And = W;      //      West
                            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y - 1];
                            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y - 1] > Homes[Index_Robot.X - 1][Index_Robot.Y - 1] )
                            {
                                Angle_Move_Robot_First = S ;
                                Angle_Move_Robot_Second = SW ;

                                Index_Robot.Y = Index_Robot.Y - 1;
                                return 1;
                            }
                        }
            }
            Update();
        }
    }
void Move_Robot_45_Ver2()       //   ј      捘    Ԙ        ј 45 
    {
        //char And;
        //Wall_Homes[Index_Robot.X][Index_Robot.Y] |= RPT;   //          
        
            if ( ((N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) &&  Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1] )
            {
                Angle_Move_Robot_First = N ;
                        if ( Homes[Index_Robot.X][Index_Robot.Y + 1] > Homes[Index_Robot.X][Index_Robot.Y + 2] )
                        {
                            Angle_Move_Robot_Second = N;
                            Index_Robot.Y = Index_Robot.Y + 1;
                            Type_Move = 0;
                        }
                        else
                        {
                            if ( Homes[Index_Robot.X][Index_Robot.Y + 1] > Homes[Index_Robot.X + 1][Index_Robot.Y + 1] )
                            {
                                Angle_Move_Robot_Second = NE ;
                                Index_Robot.Y = Index_Robot.Y + 1;
                                Type_Move = 1;
                            }
                            else if ( Homes[Index_Robot.X][Index_Robot.Y + 1] > Homes[Index_Robot.X - 1][Index_Robot.Y + 1] )
                            {
                                Angle_Move_Robot_Second = NW ;
                                Index_Robot.Y = Index_Robot.Y + 1;
                                Type_Move = 1;
                            }
                        }
            }
            else if ( ((E & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) &&  Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y] )
            {
                Angle_Move_Robot_First = E ;
                        if ( Homes[Index_Robot.X + 1][Index_Robot.Y] > Homes[Index_Robot.X + 2][Index_Robot.Y] )
                        {
                                
                                Angle_Move_Robot_Second = E ;
                                Index_Robot.X = Index_Robot.X + 1;
                            Type_Move = 0;
                        }
                        else
                        {
                            if (Homes[Index_Robot.X + 1][Index_Robot.Y] > Homes[Index_Robot.X + 1][Index_Robot.Y + 1] )
                            {
                                Angle_Move_Robot_Second = NE ;

                                Index_Robot.X = Index_Robot.X + 1;
                                Type_Move = 1;
                            }
                            else if (Homes[Index_Robot.X + 1][Index_Robot.Y] > Homes[Index_Robot.X + 1][Index_Robot.Y - 1] )
                            {
                                Angle_Move_Robot_Second = SE1 ;

                                Index_Robot.X = Index_Robot.X + 1;
                                Type_Move = 1;
                            }
                        }
            }
            else if ( ((W & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) &&  Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y] )
            {
                Angle_Move_Robot_First = W ;
                        if ( Homes[Index_Robot.X - 1][Index_Robot.Y] > Homes[Index_Robot.X - 2][Index_Robot.Y] )
                        {
                                Angle_Move_Robot_Second = W ;
                            Index_Robot.X = Index_Robot.X - 1;
                            Type_Move = 0;
                        }
                        else
                        {
                            if ( Homes[Index_Robot.X - 1][Index_Robot.Y] > Homes[Index_Robot.X - 1][Index_Robot.Y + 1] )
                            {
                                Angle_Move_Robot_Second = NW ;
                                Index_Robot.X = Index_Robot.X - 1;
                                Type_Move = 1;
                            }
                            else if ( Homes[Index_Robot.X - 1][Index_Robot.Y] > Homes[Index_Robot.X - 1][Index_Robot.Y - 1] )
                            {
                                Angle_Move_Robot_Second = SW ;
                                Index_Robot.X = Index_Robot.X - 1;
                                Type_Move = 1;
                            }
                        }
            }
            else if ( ((S & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1] )
            {
                Angle_Move_Robot_First = S ;
                        if ( Homes[Index_Robot.X][Index_Robot.Y - 1] > Homes[Index_Robot.X][Index_Robot.Y - 2] )
                        {        
                                Angle_Move_Robot_Second = S ;
                            Index_Robot.Y = Index_Robot.Y - 1;
                            Type_Move = 0;
                        }
                        else
                        {
                            if ( Homes[Index_Robot.X][Index_Robot.Y - 1] > Homes[Index_Robot.X + 1][Index_Robot.Y - 1] )
                            {
                                Angle_Move_Robot_Second = SE1 ;

                                Index_Robot.Y = Index_Robot.Y - 1;
                                Type_Move = 1;
                            }
                            else if ( Homes[Index_Robot.X][Index_Robot.Y - 1] > Homes[Index_Robot.X - 1][Index_Robot.Y - 1] )
                            {
                                Angle_Move_Robot_Second = SW ;

                                Index_Robot.Y = Index_Robot.Y - 1;
                                Type_Move = 1;
                            }
                        }
            }
    }
void Move_Robot_45_Ver3()      // Very Very Good Alguritm
{
    if ( Index_Robot_Point == Point_Down )
    {
        if ( Angle_Robot == NE || Angle_Robot == N )
        {
            if (((E & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1][Index_Robot.Y])
                {
                    Darage(NE);
                    Index_Robot.X = Index_Robot.X + 1 ;
                    Front_45();
                    Index_Robot_Point = Point_Left ;                     
                }
            else if (((W & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1][Index_Robot.Y])
                {
                    Darage(NW);
                    Index_Robot.X = Index_Robot.X - 1 ;
                    Front_45();
                    Index_Robot_Point = Point_Right ;                     
                }
            else if (((N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X ][Index_Robot.Y + 1])
                {
                    Darage(N);
                    Index_Robot.Y = Index_Robot.Y + 1 ;
                    Front();
                    Index_Robot_Point = Point_Down ;                     
                }
        }
        else if ( Angle_Robot == NW )
        {
            if (((W & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1][Index_Robot.Y])
                {
                    Darage(NW);
                    Index_Robot.X = Index_Robot.X - 1 ;
                    Front_45();
                    Index_Robot_Point = Point_Right ;                     
                }
            else if (((E & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1][Index_Robot.Y])
                {                                                                
                    Darage(NE);
                    Index_Robot.X = Index_Robot.X + 1 ;
                    Front_45();
                    Index_Robot_Point = Point_Left ;                     
                }
            else if (((N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X ][Index_Robot.Y + 1])
                {
                    Darage(N);
                    Index_Robot.Y = Index_Robot.Y + 1 ;
                    Front();
                    Index_Robot_Point = Point_Down ;                     
                }
        }
    }
    else if ( Index_Robot_Point == Point_Up )
    {
        if ( Angle_Robot == SE1 || Angle_Robot == S )
        {
            if (((E & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1][Index_Robot.Y])
                {
                    Darage(SE1);
                    Index_Robot.X = Index_Robot.X + 1 ;
                    Front_45();
                    Index_Robot_Point = Point_Left ;                     
                }
            else if (((W & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1][Index_Robot.Y])
                {
                    Darage(SW);
                    Index_Robot.X = Index_Robot.X - 1 ;
                    Front_45();
                    Index_Robot_Point = Point_Right ;                     
                }
            else if (((S & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X ][Index_Robot.Y - 1])
                {
                    Darage(S);
                    Index_Robot.Y = Index_Robot.Y - 1 ;
                    Front();
                    Index_Robot_Point = Point_Up ;                     
                }
        }
        else if ( Angle_Robot == SW )
        {
            if (((W & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1][Index_Robot.Y])
                {
                    Darage(SW);
                    Index_Robot.X = Index_Robot.X - 1 ;
                    Front_45();
                    Index_Robot_Point = Point_Right ;                     
                }
            else if (((E & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1][Index_Robot.Y])
                {                                                                
                    Darage(SE1);
                    Index_Robot.X = Index_Robot.X + 1 ;
                    Front_45();
                    Index_Robot_Point = Point_Left ;                     
                }
            else if (((S & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X ][Index_Robot.Y - 1])
                {
                    Darage(S);
                    Index_Robot.Y = Index_Robot.Y - 1 ;
                    Front();
                    Index_Robot_Point = Point_Down ;                     
                }
        }
    }
    else if ( Index_Robot_Point == Point_Left )
    {
        if ( Angle_Robot == NE || Angle_Robot == E )
        {
            if (((N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X ][Index_Robot.Y + 1])
                {
                    Darage(NE);
                    Index_Robot.Y = Index_Robot.Y + 1 ;
                    Front_45();
                    Index_Robot_Point = Point_Down ;                     
                }
            else if (((S & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) &&Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1])
                {
                    Darage(SE1);
                    Index_Robot.Y = Index_Robot.Y - 1 ;
                    Front_45();
                    Index_Robot_Point = Point_Up ;                     
                }
            else if (((E & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1][Index_Robot.Y])
                {
                    Darage(E);
                    Index_Robot.X = Index_Robot.X + 1 ;
                    Front();
                    Index_Robot_Point = Point_Left ;                     
                }
        }
        else if ( Angle_Robot == SE1 )
        {
            if (((S & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X ][Index_Robot.Y - 1])
                {
                    Darage(SE1);
                    Index_Robot.Y = Index_Robot.Y - 1 ;
                    Front_45();
                    Index_Robot_Point = Point_Up ;                     
                }
            else if (((N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X ][Index_Robot.Y + 1])
                {                                                                
                    Darage(NE);
                    Index_Robot.Y = Index_Robot.Y + 1 ;
                    Front_45();
                    Index_Robot_Point = Point_Down ;                     
                }
            else if (((E & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1][Index_Robot.Y])
                {
                    Darage(E);
                    Index_Robot.X = Index_Robot.X + 1 ;
                    Front();
                    Index_Robot_Point = Point_Left ;                     
                }
        }
    }
    else if ( Index_Robot_Point == Point_Right )
    {
        if ( Angle_Robot == NW || Angle_Robot == W )
        {
            if (((N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X ][Index_Robot.Y + 1])
                {
                    Darage(NW);
                    Index_Robot.Y = Index_Robot.Y + 1 ;
                    Front_45();
                    Index_Robot_Point = Point_Down ;                     
                }
            else if (((S & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1])
                {
                    Darage(SW);
                    Index_Robot.Y = Index_Robot.Y - 1 ;
                    Front_45();
                    Index_Robot_Point = Point_Up ;                     
                }
            else if (((W & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1][Index_Robot.Y])
                {
                    Darage(W);
                    Index_Robot.X = Index_Robot.X - 1 ;
                    Front();
                    Index_Robot_Point = Point_Right ;                     
                }
        }
        else if ( Angle_Robot == SW )
        {
            if (((S & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X ][Index_Robot.Y - 1])
                {
                    Darage(SW);
                    Index_Robot.Y = Index_Robot.Y - 1 ;
                    Front_45();
                    Index_Robot_Point = Point_Up ;                     
                }
            else if (((N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X ][Index_Robot.Y + 1])
                {                                                                
                    Darage(NW);
                    Index_Robot.Y = Index_Robot.Y + 1 ;
                    Front_45();
                    Index_Robot_Point = Point_Down ;                     
                }
            else if (((W & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1][Index_Robot.Y])
                {
                    Darage(W);
                    Index_Robot.X = Index_Robot.X - 1 ;
                    Front();
                    Index_Robot_Point = Point_Right ;                     
                }
        }
    }
    else if ( Index_Robot_Point == Point_Center )
    {
        if ( Angle_Robot == N )
        {
            if (((N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X ][Index_Robot.Y + 1 ])
                {
                    Darage(N);
                    Front_Half_Size_Home();
                    Index_Robot.Y = Index_Robot.Y + 1 ;
                    Index_Robot_Point = Point_Down ;                     
                }
            else if (((E & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1][Index_Robot.Y])
                {
                    Darage(E);
                    Front_Half_Size_Home();
                    Index_Robot_Point = Point_Left ;
                    Index_Robot.X = Index_Robot.X + 1 ;                     
                }
            else if (((W & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1][Index_Robot.Y ])
                {
                    Darage(W);
                    Front_Half_Size_Home();
                    Index_Robot_Point = Point_Right ;
                    Index_Robot.X = Index_Robot.X - 1 ;                     
                } 
            else if (((S & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X ][Index_Robot.Y -1])
                {
                    Darage(S);
                    Front_Half_Size_Home();
                    Index_Robot_Point = Point_Up ;
                    Index_Robot.Y = Index_Robot.Y - 1 ;                      
                }
        }
        else if ( Angle_Robot == E )
        {
            if (((E & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1][Index_Robot.Y])
                {
                    Darage(E);
                    Front_Half_Size_Home();
                    Index_Robot_Point = Point_Left ;
                    Index_Robot.X = Index_Robot.X + 1 ;                     
                }
            else if (((N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X ][Index_Robot.Y + 1 ])
                {
                    Darage(N);
                    Front_Half_Size_Home();
                    Index_Robot_Point = Point_Down ;
                    Index_Robot.Y = Index_Robot.Y + 1 ;                     
                }
            else if (((S & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X ][Index_Robot.Y -1])
                {
                    Darage(S);
                    Front_Half_Size_Home();
                    Index_Robot_Point = Point_Up ;
                    Index_Robot.Y = Index_Robot.Y - 1 ;                     
                }
            else if (((W & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1][Index_Robot.Y ])
                {
                    Darage(W);
                    Front_Half_Size_Home();
                    Index_Robot_Point = Point_Right ;
                    Index_Robot.X = Index_Robot.X - 1 ;                     
                }
        }

        else if ( Angle_Robot == W )
        {
            if (((W & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1][Index_Robot.Y ])
                {
                    Darage(W);
                    Front_Half_Size_Home();
                    Index_Robot_Point = Point_Right ;
                    Index_Robot.X = Index_Robot.X - 1 ;                     
                }
            else if (((N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X ][Index_Robot.Y + 1 ])
                {
                    Darage(N);
                    Front_Half_Size_Home();
                    Index_Robot_Point = Point_Down ;
                    Index_Robot.Y = Index_Robot.Y + 1 ;                     
                }
            else if (((S & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X ][Index_Robot.Y -1])
                {
                    Darage(S);
                    Front_Half_Size_Home();
                    Index_Robot_Point = Point_Up ;
                    Index_Robot.Y = Index_Robot.Y - 1 ;                     
                }
            else if (((E & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1][Index_Robot.Y])
                {
                    Darage(E);
                    Front_Half_Size_Home();
                    Index_Robot_Point = Point_Left ;
                    Index_Robot.X = Index_Robot.X + 1 ;                     
                }
        }
        
        else if ( Angle_Robot == S )
        {
            if (((S & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X ][Index_Robot.Y -1])
                {
                    Darage(S);
                    Front_Half_Size_Home();
                    Index_Robot_Point = Point_Up ;
                    Index_Robot.Y = Index_Robot.Y - 1 ;                      
                }
            else if (((W & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1][Index_Robot.Y ])
                {
                    Darage(W);
                    Front_Half_Size_Home();
                    Index_Robot_Point = Point_Right ;
                    Index_Robot.X = Index_Robot.X - 1 ;                   
                }
            else if (((E & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1][Index_Robot.Y])
                {
                    Darage(E);
                    Front_Half_Size_Home();
                    Index_Robot_Point = Point_Left ;
                    Index_Robot.X = Index_Robot.X + 1 ;                     
                }

            else if (((N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00) && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X ][Index_Robot.Y + 1 ])
                {
                    Darage(N);
                    Front_Half_Size_Home();
                    Index_Robot_Point = Point_Down ;
                    Index_Robot.Y = Index_Robot.Y + 1 ;                   
                }

        }
    }


}

/*
void Move_Robot_RPT()     //   ј      捘    Ԙ                 
    {
        Index_Robot_RPT.X=0;
        Index_Robot_RPT.Y=0;
        while (1)
        {
            if (Homes[Index_Robot_RPT.X][Index_Robot_RPT.Y] > Homes[Index_Robot_RPT.X][Index_Robot_RPT.Y + 1] )
            {
                Index_Robot_RPT.Y = Index_Robot_RPT.Y + 1;
                return ;
            }
            if (Homes[Index_Robot_RPT.X][Index_Robot_RPT.Y] > Homes[Index_Robot_RPT.X + 1 ][Index_Robot_RPT.Y] )
            {
                Index_Robot_RPT.X = Index_Robot_RPT.X + 1;
                return ;
            }
            if (Homes[Index_Robot_RPT.X][Index_Robot_RPT.Y] > Homes[Index_Robot_RPT.X - 1 ][Index_Robot_RPT.Y] )
            {
                Index_Robot_RPT.X = Index_Robot_RPT.X - 1;
                return ;
            }
            if (Homes[Index_Robot_RPT.X][Index_Robot_RPT.Y] > Homes[Index_Robot_RPT.X][Index_Robot_RPT.Y - 1] )
            {
                Index_Robot_RPT.Y = Index_Robot_RPT.Y - 1;
                return ;
            }
        }
    }
void Move_Robot_Speed()   //    ј      捘    Ԙ       ј     
    {
        char And;
        //Wall_Homes[Index_Robot.X][Index_Robot.Y] |= RPT;   //          
        while ( Angle_Robot == N )
        {
            And = N;      //      North
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1] )
            {
                Index_Robot.Y = Index_Robot.Y + 1;
                Darage(N);
                return ;
            }
            And = E;      //      East
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y] )
            {
                Index_Robot.X = Index_Robot.X + 1;
                Darage(E);
                return ;
            }
            And = W;      //      West
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y] )
            {
                Index_Robot.X = Index_Robot.X - 1;
                Darage(W);
                return ;
            }
            And = S;      //      South
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1] )
            {
                Index_Robot.Y = Index_Robot.Y - 1;
                Darage(S);
                return ;
            }
            Update();
        }
        while (Angle_Robot == E)
        {
            And = E;      //      East
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y] )
            {
                Index_Robot.X = Index_Robot.X + 1;
                Darage(E);
                return ;
            }
            And = N;      //      North
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1] )
            {
                Index_Robot.Y = Index_Robot.Y + 1;
                Darage(N);
                return ;
            }
            And = W;      //      West
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y] )
            {
                Index_Robot.X = Index_Robot.X - 1;
                Darage(W);
                return ;
            }
            And = S;      //      South
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1] )
            {
                Index_Robot.Y = Index_Robot.Y - 1;
                Darage(S);
                return ;
            }
            Update();
        }
        while (Angle_Robot == W)
        {
            And = W;      //      West
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y] )
            {
                Index_Robot.X = Index_Robot.X - 1;
                Darage(W);
                return ;
            }
            And = N;      //      North
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1] )
            {
                Index_Robot.Y = Index_Robot.Y + 1;
                Darage(N);
                return ;
            }
            And = E;      //      East
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y] )
            {
                Index_Robot.X = Index_Robot.X + 1;
                Darage(E);
                return ;
            }
            And = S;      //      South
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1] )
            {
                Index_Robot.Y = Index_Robot.Y - 1;
                Darage(S);
                return ;
            }
            Update();
        }
        while (Angle_Robot == S)
        {
            And = S;      //      South
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1] )
            {
                Index_Robot.Y = Index_Robot.Y - 1;
                Darage(S);
                return ;
            }
            And = E;      //      East
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y] )
            {
                Index_Robot.X = Index_Robot.X + 1;
                Darage(E);
                return ;
            }
            And = N;      //      North
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1] )
            {
                Index_Robot.Y = Index_Robot.Y + 1;
                Darage(N);
                return ;
            }
            And = W;      //      West
            And &= Wall_Homes[Index_Robot.X][Index_Robot.Y];
            if ( And == 0x00 && Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y] )
            {
                Index_Robot.X = Index_Robot.X - 1;
                Darage(W);
                return ;
            }
            Update();
        }
    }
void Finish()             //              
    {
        char And;
        if (Index_Robot.X == Finish_Home_1.X || Index_Robot.X == Finish_Home_2.X ||Index_Robot.X == Finish_Home_3.X || Index_Robot.X == Finish_Home_4.X)
        if (Index_Robot.Y == Finish_Home_1.Y || Index_Robot.Y == Finish_Home_2.Y ||Index_Robot.Y == Finish_Home_3.Y || Index_Robot.Y == Finish_Home_4.Y)
        {
            Back_Way ++ ;
            if (Index_Robot.X == 7 && Index_Robot.Y == 7)Back_Way = 2 ;
        }
        if (Back_Way == 6) Back_Way = 0;

        if (Back_Way == 0)
        {
            Finish_Home_1.X =7;Finish_Home_1.Y =7;
            Finish_Home_2.X =8;Finish_Home_2.Y =7;
            Finish_Home_3.X =7;Finish_Home_3.Y =8;
            Finish_Home_4.X =8;Finish_Home_4.Y =8;
        }
        else if (Back_Way == 1 )
        {
            Finish_Home_1.X =7;Finish_Home_1.Y =7;
            Finish_Home_2.X =7;Finish_Home_2.Y =7;
            Finish_Home_3.X =7;Finish_Home_3.Y =7;
            Finish_Home_4.X =7;Finish_Home_4.Y =7;
        }
        else if (Back_Way == 2 )
        {
            Finish_Home_1.X =7;Finish_Home_1.Y =8;
            Finish_Home_2.X =7;Finish_Home_2.Y =8;
            Finish_Home_3.X =7;Finish_Home_3.Y =8;
            Finish_Home_4.X =7;Finish_Home_4.Y =8;
        }
        else if (Back_Way == 3 )
        {
            Finish_Home_1.X =8;Finish_Home_1.Y =8;
            Finish_Home_2.X =8;Finish_Home_2.Y =8;
            Finish_Home_3.X =8;Finish_Home_3.Y =8;
            Finish_Home_4.X =8;Finish_Home_4.Y =8;
        }
        else if (Back_Way == 4 )
        {
            Finish_Home_1.X =8;Finish_Home_1.Y =7;
            Finish_Home_2.X =8;Finish_Home_2.Y =7;
            Finish_Home_3.X =8;Finish_Home_3.Y =7;
            Finish_Home_4.X =8;Finish_Home_4.Y =7;
        }
        else if (Back_Way == 5 )
        {
            Finish_Home_1.X =0;Finish_Home_1.Y =0;
            Finish_Home_2.X =0;Finish_Home_2.Y =0;
            Finish_Home_3.X =0;Finish_Home_3.Y =0;
            Finish_Home_4.X =0;Finish_Home_4.Y =0;
        }

    }
void Go()
    {
                Check_Wall();
                Move_Robot();
                Front();
                Finish();
    }
void Go_Arc()             //      ј 
    {
                //Check_Wall();
        if ( Homes[Index_Robot.X][Index_Robot.Y] > 1 )
        {
            if (Type_Move == 0)
            {
                Type_Move = Move_Robot_Arc();
                if (Type_Move == 1 )
                    {
                        Darage_Arc (Angle_Move_Robot_First);
                        Front_Half_Size_Home();
                        Darage_Arc (Angle_Move_Robot_Second);
                    }
                else if (Type_Move == 0 ){Darage_Arc (Angle_Move_Robot_First); Front(); }
            }
            else if (Type_Move == 1)
            {
                Type_Move = Move_Robot_Arc();
                if (Type_Move == 0 )
                    {
                        Darage_Arc (Angle_Move_Robot_First);
                        Front_Half_Size_Home();
                        Darage_Arc (Angle_Move_Robot_Second);
                        Front();
                    }
                else if (Type_Move == 1 ){Darage_Arc (Angle_Move_Robot_First); }
            }
        }
        else
        {
                Move_Robot_Speed();
                Front();
        }
    }
*/
void Go()
    {
                Check_Wall();
                while ( Move_Robot() == 1 )
                {
                    Update();
                }
                Front();
                    Len_Way ++;
                Finish();
    }
void Go_RPT()
    {
                Check_Wall();
                while ( Move_Robot_RPT() == 1 )
                {
                    Update();
                }
                Front();
                    Len_Way ++;
                Finish();
    }
void Go_Arc()
    {
                //Check_Wall();
        if ( Homes[Index_Robot.X][Index_Robot.Y] > 1 )
        {
            if (Type_Move == 0)
            {
                Type_Move = Move_Robot_Arc();
                if (Type_Move == 1 )
                    {
                        Darage_Arc (Angle_Move_Robot_First);
                        Front_Half_Size_Home();
                        Darage_Arc (Angle_Move_Robot_Second);
                    }
                else if (Type_Move == 0 ){Darage_Arc (Angle_Move_Robot_First); Front(); }
            }
            else if (Type_Move == 1)
            {
                Type_Move = Move_Robot_Arc();
                if (Type_Move == 0 )
                    {
                        Darage_Arc (Angle_Move_Robot_First);
                        Front_Half_Size_Home();
                        Darage_Arc (Angle_Move_Robot_Second);
                        Front();
                    }
                else if (Type_Move == 1 ){Darage_Arc (Angle_Move_Robot_First); }
            }
        }
        else
        {
                Move_Robot_Speed();
                Front();
        }
    }

void Go_Speed()
    {
                Check_Wall();
                Move_Robot_Speed();
                Front();
                    Len_Way ++;
                Finish();
    }
void Go_Speed_RPT()
    {
                Check_Wall();
                Move_Robot_Speed_RPT();
                Front();
                    Len_Way ++;
                Finish();
    }
void Go_Speed_Ver2()
    {
                Check_Wall();
                Move_Robot_Speed();
                Front();
                    Len_Way ++;
                Finish_RPT();
    }
void Go_45()
    {
                //Check_Wall();
        if ( Homes[Index_Robot.X][Index_Robot.Y] > 1 )
        {
            if (Type_Move == 0)
            {
                Type_Move = Move_Robot_45();
                if (Type_Move == 1 )
                    {
                        Darage (Angle_Move_Robot_First);
                        Front_Half_Size_Home();
                        Darage (Angle_Move_Robot_Second);
                        Front_45();
                    }
                else if (Type_Move == 0 ){Darage (Angle_Move_Robot_First); Front(); }
            }
            else if (Type_Move == 1)
            {
                Type_Move = Move_Robot_45();
                if (Type_Move == 0 )
                    {
                        Darage (Angle_Move_Robot_First);
                        Front_Half_Size_Home();
                        Darage (Angle_Move_Robot_Second);
                        Front();
                    }
                else if (Type_Move == 1 ){Darage (Angle_Move_Robot_First); Front_45();}
            }
        }
        else
        {
                Move_Robot_Speed();
                Front();
        }

        Finish();
    }
void Go_45_Ver2()
    {
                //Check_Wall();
        if ( Homes[Index_Robot.X][Index_Robot.Y] > 1 )
        {
            if (Type_Move == 0)
            {
                Move_Robot_45_Ver2();
                if (Type_Move == 1 )
                    {
                        Darage (Angle_Move_Robot_First);
                        Front_Half_Size_Home();
                        Darage (Angle_Move_Robot_Second);
                        Front_45();
                    }
                else if (Type_Move == 0 ){Darage (Angle_Move_Robot_First); Front(); }
            }
            else if (Type_Move == 1)
            {
                Move_Robot_45_Ver2();
                if (Type_Move == 0 )
                    {
                        Darage (Angle_Move_Robot_First);
                        Front_Half_Size_Home();
                        Darage (Angle_Move_Robot_Second);
                        //Front();
                    }
                else if (Type_Move == 1 ){Darage (Angle_Move_Robot_Second); Front_45();}
            }
        }
/*
        else
        {
//                Move_Robot_Speed();
//                Front();
               
            
            if ( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1 ] )
            {   
                Darage(N);
                Index_Robot.Y = Index_Robot.Y + 1 ;
            }
            else if ( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1][Index_Robot.Y ] )
            {
                Darage(E);      
                Index_Robot.X = Index_Robot.X + 1 ;               
            }
            else if ( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1][Index_Robot.Y ] )
            {
                Darage(W);   
                Index_Robot.X = Index_Robot.X - 1 ;
            }
            else if ( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1 ] )
            {
                Darage(S);
                Index_Robot.Y = Index_Robot.Y - 1 ;
            }
            
            if ( Type_Move == 0 )Front();
            else if ( Type_Move == 1 )Front_Half_Size_Home();
            
            Type_Move = 0;    
        }
*/
        Finish();
    }
void Go_45_Ver3()
{
    Model_Move = On_ALG;
    Move_Robot_45_Ver3();
    Finish();
}
void Go_Speed_RPT_NO_Update()
    {
                Check_Wall();
                Move_Robot_Speed_RPT_NO_Update();
                Front();
                    Len_Way ++;
                Finish();
    }
void Go_Speed_RPT_NO_Update_Ver2()
    {
                Check_Wall();
                Move_Robot_Speed_RPT_NO_Update_Ver2();
                Front();
                    Len_Way ++;
                Finish();
    }
/*
void Smal_Way()
{
        //char Max_Way=0;
        Finish_Home_1.X =7;
        Finish_Home_1.Y =7;
        Finish_Home_2.X =8;
        Finish_Home_2.Y =7;
        Finish_Home_3.X =7;
        Finish_Home_3.Y =8;
        Finish_Home_4.X =8;
        Finish_Home_4.Y =8;
        
        Update();     
        
        Max_Way = Homes[0][0]; 
        for ( Index_Way = Max_Way ; Index_Way > 0 ; Index_Way -- )
        {
            if ( Homes [ IPW_A.X ][ IPW_A.Y ] < Homes [ IPW_A.X ][ IPW_A.Y + 1 ] ) IPW_A.Y ++ ;
            else if ( Homes [ IPW_A.X ][ IPW_A.Y ] < Homes [ IPW_A.X + 1 ][ IPW_A.Y ] ) IPW_A.X ++ ;
            else if ( Homes [ IPW_A.X ][ IPW_A.Y ] < Homes [ IPW_A.X ][ IPW_A.Y - 1 ] ) IPW_A.Y -- ;
            else if ( Homes [ IPW_A.X ][ IPW_A.Y ] < Homes [ IPW_A.X - 1 ][ IPW_A.Y ] ) IPW_A.X -- ;
            
            if ( Homes [ IPW_B.X ][ IPW_B.Y ] < Homes [ IPW_B.X + 1 ][ IPW_B.Y ] ) IPW_B.X ++ ;
            else if ( Homes [ IPW_B.X ][ IPW_B.Y ] < Homes [ IPW_B.X ][ IPW_B.Y + 1 ] ) IPW_B.Y ++ ;
            else if ( Homes [ IPW_B.X ][ IPW_B.Y ] < Homes [ IPW_B.X ][ IPW_B.Y - 1 ] ) IPW_B.Y -- ;
            else if ( Homes [ IPW_B.X ][ IPW_B.Y ] < Homes [ IPW_B.X - 1 ][ IPW_B.Y ] ) IPW_B.X -- ;
            
            if ( Homes [ IPW_C.X ][ IPW_C.Y ] < Homes [ IPW_C.X ][ IPW_C.Y - 1 ] ) IPW_C.Y -- ;
            else if ( Homes [ IPW_C.X ][ IPW_C.Y ] < Homes [ IPW_C.X - 1 ][ IPW_C.Y ] ) IPW_C.X -- ;
            else if ( Homes [ IPW_C.X ][ IPW_C.Y ] < Homes [ IPW_C.X + 1 ][ IPW_C.Y ] ) IPW_C.X ++ ;
            else if ( Homes [ IPW_C.X ][ IPW_C.Y ] < Homes [ IPW_C.X ][ IPW_C.Y + 1 ] ) IPW_C.Y ++ ;
            
            if ( Homes [ IPW_D.X ][ IPW_D.Y ] < Homes [ IPW_D.X - 1 ][ IPW_D.Y ] ) IPW_D.X -- ;
            else if ( Homes [ IPW_D.X ][ IPW_D.Y ] < Homes [ IPW_D.X ][ IPW_D.Y - 1 ] ) IPW_D.Y -- ;
            else if ( Homes [ IPW_D.X ][ IPW_D.Y ] < Homes [ IPW_D.X + 1 ][ IPW_D.Y ] ) IPW_D.X ++ ;
            else if ( Homes [ IPW_D.X ][ IPW_D.Y ] < Homes [ IPW_D.X ][ IPW_D.Y + 1 ] ) IPW_D.Y ++ ;
            
        }

}
*/