
#ifndef __Need_Maze__
    #define __Need_Maze__ 
    #define Encoder_Pulse_One_Home 325



unsigned int Center_FCS,Max_FCS; // Front Center Sensor
unsigned int Center_FRS,Max_FRS; // Front Right Sensor
unsigned int Center_FLS,Max_FLS; // Front Left Sensor
unsigned int Center_RS,Max_RS,Min_RS; // Right Sensor
unsigned int Center_LS,Max_LS,Min_LS; // Left Sensor

void Enable_Motor()
{
    PORTD.6 = 1 ;
    PORTD.1 = 1 ;
    TCCR0 = 0x02 ;
}
void Disable_Motor()
{
    PORTD.6 = 0 ;
    PORTD.1 = 0 ;
    TCCR0 = 0x00 ;
}
void Enable_Sensor()
{
    TCCR1B = 0x01 ;
}
void Disable_Sensor()
{
    
    TCCR1B = 0x00 ;
    PORTC &= 0xe0 ;
}
    
void Lock(char AMotor)
{
        Speed_Right_Motor = 0 ;
        Speed_Left_Motor  = 0 ;
        /*
        PWM_Right_Motor = 0 ;
        PWM_Left_Motor = 0 ;
        
        PORTD.5 = 1 ;
        PORTD.7 = 0 ;
        PORTD.4 = 1 ;
        PORTD.0 = 0 ;
        delay_us(100);
        
        PORTD.5 = 0 ;
        PORTD.7 = 0 ;
        PORTD.4 = 0 ;
        PORTD.0 = 0 ;
        */
        Acceleration_Motor = AMotor ;  
                //Acceleration_Motor_Left = AMotor ;

        
        if (Wheel_Left_Motor == Front_Motor ) Wheel_Left_Motor = Back_Motor ;
        else Wheel_Left_Motor = Front_Motor ;
        
        if (Wheel_Right_Motor == Front_Motor ) Wheel_Right_Motor = Back_Motor ;
        else Wheel_Right_Motor = Front_Motor ;
}
void Correction (void)
{    
    if ( ValueFCS >= Max_FCS )
    {
        if ( ValueFCS >= Center_FCS )
        {
            Encoder_Right = Encoder_Pulse_One_Home ; 
            Encoder_Left = Encoder_Pulse_One_Home ;
        }
        else 
        {                              
            Encoder_Right = 0 ; 
            Encoder_Left = 0 ;
        }
    }
    else 
    {
        if ( ValueRS > Center_RS + 2 )
            {
                //lcd_gotoxy(0,1);lcd_putsf("1");
                Speed_Right_Motor = MSRM ;
                Speed_Left_Motor  = MSLM - 1 ;
            }
        else if ( ValueLS > Center_LS + 2 )
            {
                //lcd_gotoxy(0,1);lcd_putsf("22");
                Speed_Left_Motor = MSLM ;
                Speed_Right_Motor  = MSRM - 1 ;
            }
        else if ( ValueRS > Max_RS )
            {   
                //lcd_gotoxy(0,1);lcd_putsf("333");
                Speed_Left_Motor = MSLM ;
                Speed_Right_Motor  = MSRM - 1 ;
            }
        else if ( ValueLS > Max_LS )
            {                                    
                //lcd_gotoxy(0,1);lcd_putsf("4444");
                Speed_Right_Motor = MSRM ;
                Speed_Left_Motor  = MSLM - 1 ;
            } 
        else
            {                                     
                //lcd_gotoxy(0,1);lcd_putsf("55555");
                Speed_Right_Motor = MSRM ;
                Speed_Left_Motor  = MSLM ;
            }  
    }
            
            //sprintf(buff,"FCS %d C %d M %d ",ValueFCS,Center_FCS,Max_FCS);
            //lcd_gotoxy(0,1);lcd_puts(buff);
            //delay_ms(50);
            
    //if (ValueFCS >= Max_FCS)
    //{
    //    lcd_gotoxy(0,2);lcd_putsf("Max   ");
    //    if (ValueFCS >= Center_FCS)
    //    { 
    //        Encoder_Right = Encoder_Pulse_One_Home ; Encoder_Left = Encoder_Pulse_One_Home ;
            //PORTC.5 = 0 ;
            //Lock(1);
            //lcd_gotoxy(0,3);lcd_putsf("Center   ");  
    //    }          
        /*
        else if (( ValueFRS >= AMCFSR ) && ( ValueFLS >= AMCFSL ))
        { 
                Speed_Right_Motor = 15 ;
                Speed_Left_Motor  = 15 ; 
                Acceleration_Motor = 5 ;
        } 
        */
    //    else
    //    {
        //    Encoder_Right = 0;
        //    Encoder_Left = 0;
            //lcd_gotoxy(0,3);lcd_putsf("No Center   ");
    //    }
    //}
    //else 
    //{
        //lcd_gotoxy(0,2);lcd_putsf("Not Max ");
    //}
    /*
    else 
    {
        
        if (ValueRS > Center_RS)
            {
                Speed_Right_Motor = 10 ;
                Speed_Left_Motor  = 10 - ((ValueRS - Center_RS)/100);
            }
        else if (ValueLS > Center_LS)
            {
                Speed_Left_Motor = 10 ;
                Speed_Right_Motor  = 10 - ((ValueLS - Center_LS)/100);
            }
        else if (ValueRS < Center_RS && ValueRS > Max_RS)
            {
                Speed_Right_Motor = 10 - ((ValueRS - Center_RS)/100);
                Speed_Left_Motor  = 10 ;
            }
        else if ( ValueLS < Center_LS && ValueLS > Max_LS )
            {
                Speed_Right_Motor = 10 ;
                Speed_Left_Motor  = 10 - ((ValueLS - Center_LS)/100);
            }
        
    }
    */
}
void Front_Half_Size_Home(void)
{

}
void Right_45(void)// 45 Right
{}
void Left_45(void)// 45 Left
{}
void Front(void)
{
                    PORTC.5=1;
    Encoder_Right = 0 ; 
    Encoder_Left = 0 ; 
    
    Wheel_Right_Motor = Front_Motor ;
    Wheel_Left_Motor = Front_Motor ;
    
    //Speed_Right_Motor = 5 ;
    //Speed_Left_Motor  = 5 ; 
    
    Speed_Right_Motor = MSRM ;
    Speed_Left_Motor  = MSLM ;
    Acceleration_Motor = 1 ;     
        //Acceleration_Motor_Left = 1 ; 

    
    while ((Encoder_Right  +  Encoder_Left) < Encoder_Pulse_One_Home)  
    {
        Correction(); 
        
        /*
        sprintf(buff,"R %d_",Encoder_Right);
        lcd_gotoxy(0,0);
        lcd_puts(buff);  
        sprintf(buff,"L %d_",Encoder_Left);
        lcd_gotoxy(0,1);
        lcd_puts(buff);
        delay_ms(50);
        */
         
      
    }
    Lock(1);
                    PORTC.5=0;

    
}
void Front_45(void)// For Move 45 - Front 1 Home - Eslah
{}
void Back(void)// 180
{
    Right();
    Right();

}
void Right(void)// 90 Right
{
    Encoder_Right = 0 ; 
    Encoder_Left = 0 ; 
    
    Wheel_Right_Motor = Back_Motor ;
    Wheel_Left_Motor = Front_Motor ;
    
    Speed_Right_Motor = MSRM ;
    Speed_Left_Motor  = MSLM ;
        Acceleration_Motor = 1 ;
        //Acceleration_Motor_Left = 1 ;

    
    while ((Encoder_Right  +  Encoder_Left) < 100)
    //while ((Encoder_Right  ) < 150)   
    {
        //Correction(); 
        //sprintf(buff,"%d_",Encoder_Right);
        //lcd_gotoxy(0,0);
        //lcd_puts(buff);  
        //sprintf(buff,"%d_",Encoder_Left);
        //lcd_gotoxy(0,1);
        //lcd_puts(buff); 
      
    } 
    Lock(1);

}
void Left(void)// 90 Left
{
    Encoder_Right = 0 ; 
    Encoder_Left = 0 ; 
    
    Wheel_Right_Motor = Front_Motor ;
    Wheel_Left_Motor = Back_Motor ;
    
    Speed_Right_Motor = MSRM ;
    Speed_Left_Motor  = MSLM ;
        Acceleration_Motor = 1 ;
        //Acceleration_Motor_Left = 1 ;

    
    while ((Encoder_Right  +  Encoder_Left) < 80)  
    {
        //Correction(); 
        //sprintf(buff,"%d_",Encoder_Right);
        //lcd_gotoxy(0,0);
        //lcd_puts(buff);  
        //sprintf(buff,"%d_",Encoder_Left);
        //lcd_gotoxy(0,1);
        //lcd_puts(buff); 
      
    } 
    Lock(1);

}
void Right_Arc(void)// Arc 90 Right
{

}
void Left_Arc(void)// Arc 90 Left
{}
unsigned int Read_Sensor(unsigned char Namber_Sensor_Wall)
// First Wall ==> return 1
// Second Wall ==> return 2
// Non Wall ==> return 0
{

    if (Namber_Sensor_Wall == RS)
    {
        if (ValueRS >= Max_RS)
            {
                return 1;
            }
        else 
            {
                return 0;
            }
    }
    else if (Namber_Sensor_Wall == FS)
    {
        if ((ValueFRS >= Max_FRS) && (ValueFLS >= Max_FLS))
            {
                return 1;
            }
        else 
            {
                return 0;
            }
    } 
    else if (Namber_Sensor_Wall == LS)
    {
        if (ValueLS >= Max_LS)
            {
                return 1;
            }
        else 
            {
                return 0;
            }
    }
}
   
#endif
